package com.duolun.rest.service;

import org.dom4j.Element;
import org.apache.cxf.endpoint.Client;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import java.net.URLDecoder;
import org.apache.cxf.jaxws.endpoint.dynamic.JaxWsDynamicClientFactory;
import com.duolun.framework.util.encrypthandle.UrlCodeTool;
import com.duolun.rest.persistence.MaExaminerInfo;
import java.util.concurrent.ExecutorService;
import com.duolun.rest.persistence.MaCdsbinfo;
import java.util.Calendar;
import com.duolun.rest.persistence.EsCheckCar;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.HashMap;
import com.duolun.rest.persistence.EsExampointway;
import java.util.Random;
import com.duolun.rest.common.client.SupervisePool;
import java.util.Iterator;
import com.duolun.rest.common.client.HeChiWebServiceClient;
import com.duolun.rest.common.client.HeZhouWebServiceClient;
import java.util.Map;
import com.duolun.framework.util.imagehandle.ImageUtils;
import com.duolun.rest.auth.PropertiesConfig;
import com.duolun.framework.util.encrypthandle.SHA;
import com.duolun.rest.bean.other.KaoShengXinXi;
import java.util.concurrent.ConcurrentHashMap;
import com.duolun.rest.persistence.EsDrvpreasign;
import java.util.List;
import com.duolun.rest.bean.other.jgcarinfo.JgCarInfo;
import org.apache.commons.lang.StringUtils;
import java.util.ArrayList;
import java.util.Date;
import com.duolun.rest.bean.common.CommonFileld;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import com.duolun.rest.persistence.EsCarinfo;
import com.duolun.framework.common.exception.RspException;
import com.duolun.framework.util.encrypthandle.MD5;
import com.duolun.rest.common.variable.ConfigParam;
import com.duolun.rest.bean.rsp.GetExaminationStudentInfoRsp;
import javax.ws.rs.core.Context;
import javax.servlet.http.HttpServletRequest;
import org.springframework.web.bind.annotation.RequestBody;
import com.duolun.rest.bean.req.GetExaminationStudentInfoReq;
import org.slf4j.LoggerFactory;
import com.duolun.rest.common.component.WxsJgPostService;
import com.duolun.rest.db.adapter.IExaminerLoginDbAdapter;
import com.duolun.framework.common.ICompositeCallDbAdapter;
import com.duolun.rest.common.component.ThirdPartHandleService;
import com.duolun.rest.db.adapter.IEsRnsbTempDbAdapter;
import com.duolun.rest.db.adapter.IExamTimeDbAdapter;
import com.duolun.rest.db.adapter.IWebOperateLogDbAdapter;
import com.duolun.rest.db.adapter.IExamineeInfoDbAdapter;
import com.duolun.rest.db.adapter.IInitializationDbAdapter;
import com.duolun.rest.db.adapter.IExaminerInfoDbAdapter;
import com.duolun.rest.db.adapter.ICarExamInfoDbAdapter;
import com.duolun.framework.common.valid.ReqConstraintHandler;
import javax.annotation.Resource;
import com.duolun.framework.common.ICommonMethodDbAdapter;
import org.slf4j.Logger;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class CarDownloadStuInfoService
{
    private static final Logger LOGGER;
    @Resource(name = "commonMethodDbAdapter")
    private ICommonMethodDbAdapter commonMethodDbAdapter;
    @Resource(name = "reqConstraintHandler")
    private ReqConstraintHandler reqConstraintHandler;
    @Resource(name = "carExamInfoDbAdapter")
    private ICarExamInfoDbAdapter carExamInfoDbAdapter;
    @Resource(name = "examinerInfoDbAdapter")
    private IExaminerInfoDbAdapter examinerInfoDbAdapter;
    @Resource(name = "initializationDbAdapter")
    private IInitializationDbAdapter initializationDbAdapter;
    @Resource(name = "examineeInfoDbAdapter")
    private IExamineeInfoDbAdapter examineeInfoDbAdapter;
    @Resource(name = "webOperateLogDbAdapter")
    private IWebOperateLogDbAdapter webOperateLogDbAdapter;
    @Resource(name = "examTimeDbAdapter")
    private IExamTimeDbAdapter examTimeDbAdapter;
    @Resource(name = "esRnsbTempDbAdapter")
    private IEsRnsbTempDbAdapter esRnsbTempDbAdapter;
    @Resource(name = "thirdPartHandleService")
    private ThirdPartHandleService thirdPartHandleService;
    @Resource(name = "CompositeCallDbAdapter")
    private ICompositeCallDbAdapter compositeCallDbAdapter;
    @Resource(name = "examinerLoginDbAdapter")
    private IExaminerLoginDbAdapter examinerLoginDbAdapter;
    @Resource(name = "wxsJgPostService")
    private WxsJgPostService wxsJgPostService;
    
    static {
        LOGGER = LoggerFactory.getLogger(CarDownloadStuInfoService.class);
    }
    
    public CarDownloadStuInfoService() {
    }
    
    @ResponseBody
    @RequestMapping(value = { "/exam/getExaminationStudentInfo.ws" }, method = { RequestMethod.POST }, produces = { "application/xml", "application/json" })
    public GetExaminationStudentInfoRsp carDownloadStuInfoController(@RequestBody GetExaminationStudentInfoReq getExaminationStudentInfoReq, @Context HttpServletRequest request) throws Exception {
        this.commonMethodDbAdapter.checkAuth(this.getClass());
        String interfaceCode = this.commonMethodDbAdapter.getInterfaceCode("1012", request);
        this.reqConstraintHandler.validParameter(getExaminationStudentInfoReq, request);
        GetExaminationStudentInfoRsp response = new GetExaminationStudentInfoRsp();
        String carIdString = getExaminationStudentInfoReq.getBody().getCarId();
        String kdidString = getExaminationStudentInfoReq.getBody().getExaminationRoomId();
        String ksyCode = getExaminationStudentInfoReq.getBody().getExaminerName();
        String siteVersion = ConfigParam.SITE_VERSION;
        if (!getExaminationStudentInfoReq.getHead().getCheckCode().equals("longlongago") && (getExaminationStudentInfoReq.getHead().getCheckCode() == null || !MD5.md5(carIdString + kdidString + ksyCode).equalsIgnoreCase(getExaminationStudentInfoReq.getHead().getCheckCode()))) {
            throw new RspException("1", "数据下载初始化验证失败!");
        }
        long carId = 0L;
        long kdid;
        try {
            carId = Long.parseLong(carIdString.trim());
            kdid = Long.parseLong(kdidString.trim());
        }
        catch (Exception e) {
            throw new RspException("1", "参数类型转换错误");
        }
        this.der2VersionIsRight(kdid);
        this.checkInExamTime(kdid);
        String sysset2380 = this.initializationDbAdapter.queryMaSyssetByCache(Long.valueOf(kdid), 2380);
        if ("1".equals(sysset2380)) {
            String sysset2381 = this.initializationDbAdapter.queryMaSyssetByCache(Long.valueOf(kdid), 2303);
            this.checkKgStartExaminee(sysset2381, kdid);
        }
        String sysset2382 = this.initializationDbAdapter.queryMaSyssetByCache(Long.valueOf(kdid), 2415);
        if (Integer.parseInt(sysset2382) > 0) {
            int num = this.checkStatusGoodCarNum(Long.valueOf(kdid));
            if (num < Integer.parseInt(sysset2382)) {
                throw new RspException("1", "考车自检合格数量不得少于" + sysset2382 + "辆,当前合格数量为" + num + "辆");
            }
        }
        EsCarinfo esCarInfo = this.getEsCarinfoAndCheckCar(carId);
        String carName = esCarInfo.getCarcode() + "(" + esCarInfo.getCarno() + ")";
        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "地点版本=" + siteVersion + "/开始请求下载考生...");
        if ("44".equals(siteVersion)) {
            this.checkSignCountforSiteVersion44(esCarInfo);
        }
        String sysset2383 = this.initializationDbAdapter.queryMaSyssetByCache(Long.valueOf(kdid), 2404);
        if ("1".equals(sysset2383)) {
            String sysset2384 = this.initializationDbAdapter.queryMaSyssetByCache(Long.valueOf(kdid), 2405);
            this.CheckWaitStuInfoCount(esCarInfo, sysset2384);
        }
        if ("32".equals(siteVersion)) {
            String sysset2385 = this.initializationDbAdapter.queryMaSyssetByCache(Long.valueOf(kdid), 2303);
            String sysset2386 = this.initializationDbAdapter.queryMaSyssetByCache(Long.valueOf(kdid), 2405);
            this.firstAssignCarIsComplete(esCarInfo, sysset2385, sysset2386);
        }
        String sysset2387 = this.initializationDbAdapter.queryMaSyssetByCache(Long.valueOf(kdid), 190);
        String sysset2388 = this.initializationDbAdapter.queryMaSyssetByCache(Long.valueOf(kdid), 191);
        String sysset2389 = this.initializationDbAdapter.queryMaSyssetByCache(Long.valueOf(kdid), 300);
        int numShangCheSys190 = 1;
        if (!siteVersion.equals("test")) {
            if ("0".equals(sysset2389)) {
                this.getJgAssignCarNew(sysset2387, sysset2388, esCarInfo);
                return this.returnJgAssignCarNewRsp(sysset2387, esCarInfo, response);
            }
            if ("1".equals(sysset2389)) {
                numShangCheSys190 = this.LocalAssignCarNew(sysset2387, sysset2388, esCarInfo, response);
            }
            else if ("3".equals(sysset2389)) {
                if (!siteVersion.equals("8")) {
                    if (siteVersion.equals("18")) {
                        this.GuilinJingYingAssignCar(sysset2387, esCarInfo);
                    }
                    else if (siteVersion.equals("58")) {
                        this.HeBeiAssignCar(esCarInfo);
                    }
                }
            }
            else {
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "分车模式错误sysset300=" + sysset2389);
                throw new RspException("1", "分车模式错误,请查看考点参数300配置(0-监管分车,1-本地分车)");
            }
        }
        return this.returnLocalAssignCarNewRsp(numShangCheSys190, esCarInfo, response);
    }
    
    public void getJgAssignCarNew(String sysset190, String sysset191, EsCarinfo esCarInfo) throws Exception {
        String kscx = esCarInfo.getCartype();
        String kchp = esCarInfo.getCarcode();
        String kskm = esCarInfo.getEsExampointdetail().getType();
        String ksdd = esCarInfo.getEsExampointdetail().getCode();
        Long kdid = esCarInfo.getEsExampointdetail().getId();
        String carid = kchp + "(" + esCarInfo.getCarno() + ")";
        String dateTime = CommonFileld.formatterYmdNoConnect.format(new Date());
        String sysset192 = null;
        String sysset193;
        String sysset194;
        try {
            sysset193 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 452);
            sysset194 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2109);
            sysset192 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2410);
        }
        catch (Exception e) {
            throw new RspException("1", e);
        }
        int numShangCheSys190 = (int)Integer.valueOf(sysset190);
        int numDengDaiSys191 = (int)Integer.valueOf(sysset191);
        int realReqNum = numShangCheSys190 + numDengDaiSys191;
        String sysset195 = null;
        if (ConfigParam.SITE_VERSION.contains("ZHENGZHOU") || ConfigParam.SITE_VERSION.contains("YICHANG") || ConfigParam.SITE_VERSION.contains("ShenYang")) {
            sysset195 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2055);
            if ("1".equals(sysset195)) {
                this.autoAssignJgfcTask(kdid, ksdd, kskm, realReqNum, sysset194, kscx);
                esCarInfo = this.carExamInfoDbAdapter.getCarInfoByCarId((long)esCarInfo.getId());
            }
        }
        String sfzmhmListLs = esCarInfo.getCardNoArray();
        String ksxlListLs = esCarInfo.getCarWayArray();
        if (sfzmhmListLs != null && !"".equals(sfzmhmListLs)) {
            if (sfzmhmListLs.length() < 8) {
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "清空无效证件号，sfzmhmListLs=" + sfzmhmListLs);
                sfzmhmListLs = null;
                ksxlListLs = null;
                esCarInfo.setCardNoArray(null);
                this.carExamInfoDbAdapter.updateCarInfo(esCarInfo);
            }
            if ("3".equals(kskm) && ksxlListLs == null) {
                sfzmhmListLs = null;
                esCarInfo.setCardNoArray(null);
                this.carExamInfoDbAdapter.updateCarInfo(esCarInfo);
            }
        }
        if (sfzmhmListLs != null && !"".equals(sfzmhmListLs)) {
            if ("1".equals(sysset194)) {
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "监管分车开启考一待一模式");
            }
            else if ("2".equals(sysset194)) {
                realReqNum = this.examineeInfoDbAdapter.onExamineeingStuNum(ksdd, kscx, kskm, kchp);
            }
            else {
                realReqNum = 0;
            }
        }
        else if ("1".equals(sysset193)) {
            int numWait = this.examineeInfoDbAdapter.getUnExamExamineeNumJg(ksdd, dateTime, kscx, kchp, kskm);
            if (numWait == 0) {
                realReqNum = 0;
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "外壳自动更新模式，es_drvpreasign表已无ksdd=" + ksdd + "/kscx=" + kscx + "/kskm=" + kskm + "/kszt=(2,3,4)的待分配考生");
            }
        }
        String sysset196 = null;
        if (ConfigParam.SITE_VERSION.contains("tsdd")) {
            sysset196 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2053);
            if (!"0".equals(sysset196)) {
                int extraNum = this.checkDrvInCarCount(esCarInfo, sysset196);
                if (extraNum < realReqNum) {
                    realReqNum = extraNum;
                    CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "启用考车人数限制功能，原计划请求人数由" + realReqNum + "改为" + extraNum + ",若有疑问请查看参数2053");
                }
            }
        }
        if (ConfigParam.SITE_VERSION.contains("LinYi")) {
            sysset196 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2053);
            String ksy1sfzmhm = esCarInfo.getPmUser().getSfzmhm();
            if (!"0".equals(sysset196)) {
                int numksrs = this.examineeInfoDbAdapter.getNumKsy1Sfzmhm(ksy1sfzmhm);
                if (numksrs >= (int)Integer.valueOf(sysset196)) {
                    int numUnfinish = this.examineeInfoDbAdapter.getUnFinishKsy1Sfzmhm(ksy1sfzmhm, kchp);
                    if (numUnfinish > 0) {
                        realReqNum = 0;
                    }
                    else {
                        throw new RspException("1", "考试员(" + ksy1sfzmhm + ")已达今天考试人数上限(" + sysset196 + ")");
                    }
                }
                else {
                    int numtemp = (int)Integer.valueOf(sysset196) - numksrs;
                    if (realReqNum > numtemp) {
                        realReqNum = numtemp;
                    }
                }
            }
        }
        else if ("3".equals(ConfigParam.SITE_VERSION) && realReqNum > 0) {
            String sysset197 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2395);
            String sysset198 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2396);
            realReqNum = this.autoAssignQzAqy(sysset197, sysset198, esCarInfo);
            realReqNum = 0;
        }
        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "历史信息:kskm=" + kskm + "/realReqNum=" + realReqNum + "/sfzmhmListLs=" + sfzmhmListLs + "/ksxlListLs=" + ksxlListLs);
        if ("36".equals(ConfigParam.SITE_VERSION)) {
            if ("5".equals(ConfigParam.SITE_VERSION) && realReqNum > 0) {
                this.thirdPartHandleService.loginOutSafeMan_ShangHai(esCarInfo);
            }
            if (esCarInfo.getMaExaminerInfoByExaminerId1() != esCarInfo.getMaExaminerInfoByExaminerId()) {
                throw new RspException("1", "当前考车安全员应为:" + esCarInfo.getMaExaminerInfoByExaminerId1().getName());
            }
        }
        String[] sfzmhmArr = null;
        JgCarInfo jgCarInfo = null;
        List<String> cardNos = new ArrayList();
        boolean flagGetJgDataSucc = false;
        if (realReqNum > 0) {
            String sysset199 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2045);
            Long kscc = this.getJgAssignKscc(esCarInfo, kskm, sysset199);
            if ("1".equals(ConfigParam.V_Use_NewJg_Mode)) {
                jgCarInfo = this.thirdPartHandleService.sendForWriteObjectOut_17CB3(realReqNum, kscc, esCarInfo);
            }
            else if ("2".equals(ConfigParam.V_Use_NewJg_Mode)) {
                jgCarInfo = this.thirdPartHandleService.sendForWriteObjectOut_17CB3_2023(realReqNum, kscc, esCarInfo);
            }
            if (jgCarInfo == null || "".equals(jgCarInfo)) {
                if (sfzmhmListLs != null && !"".equals(sfzmhmListLs)) {
                    sfzmhmArr = sfzmhmListLs.split(",");
                    for (int j = 0; j < sfzmhmArr.length; ++j) {
                        cardNos.add(sfzmhmArr[j]);
                    }
                }
            }
            else {
                flagGetJgDataSucc = true;
                cardNos = jgCarInfo.getCardNos();
                if ("1".equals(sysset192)) {
                    String scontent = CommonFileld.formatterYmdHms.format(new Date()) + "考生" + esCarInfo.getCardNoArray() + ",监管分车到" + carid + "号车考试";
                    this.webOperateLogDbAdapter.saveSuccessLog(scontent, "监管分车");
                }
                if (ConfigParam.SITE_VERSION.contains("ShiJiaZhuang")) {
                    this.wxsJgPostService.autoArrangeStuInfo((long)kdid, esCarInfo.getCardNoArray(), esCarInfo.getCarWayArray(), kscc, kchp, realReqNum);
                }
            }
        }
        else if (sfzmhmListLs != null && !"".equals(sfzmhmListLs)) {
            sfzmhmArr = sfzmhmListLs.split(",");
            for (int i = 0; i < sfzmhmArr.length; ++i) {
                cardNos.add(sfzmhmArr[i]);
            }
        }
        for (int i = 0; i < cardNos.size(); ++i) {
            EsDrvpreasign drvpreasign = null;
            drvpreasign = this.examineeInfoDbAdapter.getAllExamineeInfoByCardNo((String)cardNos.get(i), dateTime, ksdd, kskm, "", "");
            if (drvpreasign == null) {
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "数据库无此考生:" + (String)cardNos.get(i));
                this.deleteStuInfoSfz((String)cardNos.get(i), esCarInfo, drvpreasign);
            }
            else {
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "监管分车前:" + drvpreasign.getXm() + "/" + drvpreasign.getSfzmhm() + "/kskm=" + drvpreasign.getKskm() + "/ksxl=" + drvpreasign.getKsxl() + "/kszt=" + drvpreasign.getKszt() + "/flag=" + drvpreasign.getFlag() + "/carcode=" + drvpreasign.getCarCode() + "/kssycs=" + drvpreasign.getKssycs() + "/sfqk=" + drvpreasign.getSfqk());
                if ("17".equals(ConfigParam.SITE_VERSION) && 6 == (byte)drvpreasign.getKszt()) {
                    this.deleteStuInfoSfz((String)cardNos.get(i), esCarInfo, drvpreasign);
                }
                else if (!"1".equals(sysset194) && !flagGetJgDataSucc && (5 == (byte)drvpreasign.getKszt() || "1".equals(drvpreasign.getFlag()) || "1".equals(drvpreasign.getSfqk()) || (!StringUtils.isEmpty(drvpreasign.getCarCode()) && !kchp.equals(drvpreasign.getCarCode())))) {
                    this.deleteStuInfoSfz((String)cardNos.get(i), esCarInfo, drvpreasign);
                }
                else {
                    this.examineeInfoDbAdapter.evict(drvpreasign);
                    if (!kchp.equals(drvpreasign.getCarCode())) {
                        drvpreasign.setCarCode(kchp);
                    }
                    drvpreasign.setXh(Integer.valueOf(100 + i));
                    this.examineeInfoDbAdapter.updateExamineeInfo(drvpreasign);
                }
            }
        }
    }
    
    public GetExaminationStudentInfoRsp returnJgAssignCarNewRsp(String sysset190, EsCarinfo esCarInfo, GetExaminationStudentInfoRsp response) throws Exception {
        String siteVersion = ConfigParam.SITE_VERSION;
        String kchp = esCarInfo.getCarcode();
        String kskm = esCarInfo.getEsExampointdetail().getType();
        String carid = kchp + "(" + esCarInfo.getCarno() + ")";
        Long kdid = esCarInfo.getEsExampointdetail().getId();
        int numShangCheSys190 = (int)Integer.valueOf(sysset190);
        if (ConfigParam.SITE_VERSION.contains("JILIN") || ConfigParam.SITE_VERSION.contains("YICHANG") || ConfigParam.SITE_VERSION.contains("ShenYang") || ConfigParam.SITE_VERSION.contains("ZHENGZHOU")) {
            this.autoAssignFcslIsRight(esCarInfo);
        }
        boolean motorIsLianKao = false;
        if ("1".equals(esCarInfo.getEsExampointdetail().getIsMotor())) {
            String sysset191 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2381);
            if ("1".equals(sysset191) || "4".equals(sysset191)) {
                motorIsLianKao = true;
            }
        }
        Map<String, String> ksxlMaps = new ConcurrentHashMap();
        if ("3".equals(kskm) || (motorIsLianKao && "XJ_YILI".equals(siteVersion))) {
            try {
                ksxlMaps = this.initializationDbAdapter.getKsxlMapsByCache(kdid);
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "考试线路初始：" + ((ksxlMaps == null) ? "无线路" : ksxlMaps.toString()));
            }
            catch (Exception e) {
                throw new RspException("1", "读取本地线路表出错");
            }
            if (ksxlMaps == null) {
                throw new RspException("1", "本地监管线路没有设置");
            }
        }
        StringBuilder hql = new StringBuilder();
        hql.append(" from ").append(EsDrvpreasign.class.getName()).append(" t where t.sfqk <> '1' and t.flag <> '1' ");
        hql.append(" and t.kszt in (0,1,2,3,4)");
        hql.append(" and t.carCode='").append(kchp).append("'");
        hql.append(" and t.ykrq = trunc(sysdate) order by t.xh,t.kszt desc");
        List<EsDrvpreasign> esDrvpreasignsJgList = new ArrayList();
        esDrvpreasignsJgList = this.examineeInfoDbAdapter.getDrvpreasignInfoListByHQL(hql);
        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "分车人数esDrvpreasignsJgList=" + esDrvpreasignsJgList.size());
        List<KaoShengXinXi> listJg = new ArrayList();
        if (esDrvpreasignsJgList.size() <= 0) {
            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "该车辆暂时没有考生sql=" + hql.toString());
            throw new RspException("1", carid + "该车辆暂时没有考生");
        }
        String log_data = null;
        String sysset192 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2410);
        for (int indexJg = 0; indexJg < esDrvpreasignsJgList.size() && indexJg < numShangCheSys190; ++indexJg) {
            EsDrvpreasign esDrvpreasignDownLoad = (EsDrvpreasign)esDrvpreasignsJgList.get(indexJg);
            log_data = "考生:" + esDrvpreasignDownLoad.getXm() + "/" + esDrvpreasignDownLoad.getSfzmhm() + "/监管分车" + carid;
            if ("50".equals(siteVersion)) {
                this.NjRnsbAdd(esCarInfo, esDrvpreasignDownLoad);
            }
            if ((byte)esDrvpreasignDownLoad.getKszt() < 3) {
                esDrvpreasignDownLoad.setKszt(Byte.valueOf("3"));
                if ("ShangHai".equals(siteVersion) || "5".equals(siteVersion)) {
                    this.webOperateLogDbAdapter.saveShangHaiLog(esDrvpreasignDownLoad.getSfzmhm(), kskm, (int)(byte)esDrvpreasignDownLoad.getKszt(), 3, "3", kchp);
                }
            }
            if ("2".equals(kskm)) {
                String sjxmdm = this.getGateZwh(kdid, esDrvpreasignDownLoad);
                if (sjxmdm != null && !"".equals(sjxmdm)) {
                    esDrvpreasignDownLoad.setSjxmdm(sjxmdm);
                }
            }
            if (StringUtils.isEmpty(esDrvpreasignDownLoad.getKsy1())) {
                if ("0".equals(ConfigParam.KSY1)) {
                    if (esCarInfo.getMaExaminerInfoByExaminerId() != null) {
                        esDrvpreasignDownLoad.setKsy1(esCarInfo.getMaExaminerInfoByExaminerId().getCardNo());
                    }
                }
                else if ("1".equals(ConfigParam.KSY1) && esCarInfo.getPmUser().getSfzmhm() != null) {
                    esDrvpreasignDownLoad.setKsy1(esCarInfo.getPmUser().getSfzmhm());
                }
            }
            if (StringUtils.isEmpty(esDrvpreasignDownLoad.getKsy1sfzmhm())) {
                if (siteVersion.equals("FZAQY")) {
                    String aqyCode = this.getAqyCode(esDrvpreasignDownLoad, esCarInfo);
                    esDrvpreasignDownLoad.setKsy1sfzmhm(aqyCode);
                }
                else if ("3".equals(ConfigParam.KSY1SFZMHM) || "3".equals(siteVersion) || "5".equals(siteVersion)) {
                    if (esCarInfo.getMaExaminerInfoByExaminerId1() != null) {
                        esDrvpreasignDownLoad.setKsy1sfzmhm(esCarInfo.getMaExaminerInfoByExaminerId1().getCardNo());
                    }
                }
                else if ("0".equals(ConfigParam.KSY1SFZMHM)) {
                    if (esCarInfo.getMaExaminerInfoByExaminerId() != null) {
                        esDrvpreasignDownLoad.setKsy1sfzmhm(esCarInfo.getMaExaminerInfoByExaminerId().getCardNo());
                    }
                }
                else if ("2".equals(ConfigParam.KSY1SFZMHM)) {
                    if (esCarInfo.getMaExaminerInfoByExaminerId() != null) {
                        esDrvpreasignDownLoad.setKsy1sfzmhm(esCarInfo.getMaExaminerInfoByExaminerId().getCode());
                    }
                }
                else if ("1".equals(ConfigParam.KSY1SFZMHM) && esCarInfo.getPmUser().getSfzmhm() != null) {
                    esDrvpreasignDownLoad.setKsy1sfzmhm(esCarInfo.getPmUser().getSfzmhm());
                }
            }
            if ("3".equals(kskm)) {
                String[] ksxlArr = null;
                String ksxlListLs = esCarInfo.getCarWayArray();
                Date assignDate = esCarInfo.getAssignTime();
                List<String> carWays = new ArrayList();
                if (ksxlListLs != null && !"".equals(ksxlListLs)) {
                    ksxlArr = ksxlListLs.split(",");
                    for (int i = 0; i < ksxlArr.length; ++i) {
                        carWays.add(ksxlArr[i]);
                    }
                }
                if (carWays.size() == 1) {
                    if (ksxlMaps.get(carWays.get(0)) != null) {
                        esDrvpreasignDownLoad.setKsxl((String)ksxlMaps.get(carWays.get(0)));
                        log_data = log_data + "/线路" + (String)carWays.get(0) + "(" + (String)ksxlMaps.get(carWays.get(0)) + ")";
                    }
                    else {
                        esCarInfo.setCardNoArray(null);
                        this.carExamInfoDbAdapter.updateCarInfo(esCarInfo);
                        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "线路异常，请检查平台线路映射设置");
                        throw new RspException("1", "线路异常，请检查平台线路映射设置");
                    }
                }
                else if (carWays.size() == 0) {
                    CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "监管没有分配线路/carWays.size()=0");
                    if (!StringUtils.isEmpty(esDrvpreasignDownLoad.getKsxl())) {
                        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "/历史线路ksxl=" + esDrvpreasignDownLoad.getKsxl());
                    }
                    else {
                        String ksxlHistory = null;
                        try {
                            ksxlHistory = this.examineeInfoDbAdapter.getKsxlFordrv(kskm, esCarInfo.getCarcode(), "0", CommonFileld.formatterYmdHmsNoConnect.format(assignDate));
                        }
                        catch (Exception e3) {
                            throw new RspException("1", e3);
                        }
                        if (ksxlHistory == null) {
                            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "当前车辆今天无历史线路");
                        }
                        else {
                            esDrvpreasignDownLoad.setKsxl(ksxlHistory);
                            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "当前车辆历史线路值(es_jgproc)ksxlHistory=" + ksxlHistory);
                        }
                    }
                }
                else if (carWays.size() > 1) {
                    CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "监管线路组长度carWays.size()=" + esCarInfo.getCarWayArray());
                    String ksxlTemp = null;
                    String nextLocalKsxl = null;
                    try {
                        ksxlTemp = this.examineeInfoDbAdapter.getKsxlFordrv(kskm, esCarInfo.getCarcode(), "0", CommonFileld.formatterYmdHmsNoConnect.format(assignDate));
                    }
                    catch (Exception e2) {
                        throw new RspException("1", e2);
                    }
                    if (ksxlTemp == null) {
                        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "当前车辆今天无历史线路");
                        ksxlTemp = (String)ksxlMaps.get(carWays.get(0));
                        if (ksxlTemp == null) {
                            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "线路映射错误，请检查平台线路设置");
                            throw new RspException("1", "线路映射错误，请检查平台线路设置");
                        }
                        esDrvpreasignDownLoad.setKsxl(ksxlTemp);
                    }
                    else {
                        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "当前车辆历史线路值(es_jgproc)ksxlTemp=" + ksxlTemp);
                        ksxlTemp = (String)ksxlMaps.get(ksxlTemp);
                        String nextJgksxl = null;
                        int j = 0;
                        while (j < carWays.size()) {
                            if (ksxlTemp.equals(carWays.get(j))) {
                                nextJgksxl = ((j == carWays.size() - 1) ? ((String)carWays.get(0)) : ((String)carWays.get(j + 1)));
                                break;
                            }
                            ++j;
                        }
                        if (nextJgksxl == null) {
                            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "线路计算出现错误，jgCarInfo.getCarWays()=");
                            throw new RspException("1", "线路计算出现错误，jgCarInfo.getCarWays()=");
                        }
                        ksxlTemp = (String)ksxlMaps.get(nextJgksxl);
                        esDrvpreasignDownLoad.setKsxl(ksxlTemp);
                    }
                    log_data = log_data + "/线路" + (String)ksxlMaps.get(ksxlTemp) + "(" + ksxlTemp + ")";
                }
            }
            this.examineeInfoDbAdapter.updateExamineeInfo(esDrvpreasignDownLoad);
            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "下放考生:" + esDrvpreasignDownLoad.getXm() + "/" + esDrvpreasignDownLoad.getSfzmhm() + "/kskm=" + esDrvpreasignDownLoad.getKskm() + "/ksxl=" + esDrvpreasignDownLoad.getKsxl() + "/kszt=" + esDrvpreasignDownLoad.getKszt() + "/ksy1=" + esDrvpreasignDownLoad.getKsy2() + "/ksy1sfzmhm=" + esDrvpreasignDownLoad.getKsy1());
            if ("1".equals(sysset192)) {
                this.webOperateLogDbAdapter.saveSuccessLog(log_data, "监管分车", "rest");
            }
            KaoShengXinXi ksxx = new KaoShengXinXi();
            if ("5".equals(siteVersion)) {
                ksxx.setXm(SHA.sha(esDrvpreasignDownLoad.getKscx() + "_" + esDrvpreasignDownLoad.getSfcode()).substring(2, 12));
            }
            else if ("32".equals(siteVersion) && "3".equals(kskm)) {
                ksxx.setXm(new StringBuilder().append(esDrvpreasignDownLoad.getXh1()).toString());
            }
            else if ("2".equals(siteVersion) || "GX_BEIHAI".equals(siteVersion)) {
                ksxx.setXm(esDrvpreasignDownLoad.getSfcode());
            }
            else {
                ksxx.setXm(esDrvpreasignDownLoad.getXm());
            }
            if ("15-1".equals(siteVersion) || "15-2".equals(siteVersion) || "21".equals(siteVersion) || "55".equals(siteVersion) || "49".equals(siteVersion)) {
                ksxx.setJxmc(esDrvpreasignDownLoad.getSjxmdm());
            }
            else {
                ksxx.setJxmc(esDrvpreasignDownLoad.getDlr());
            }
            Label_3016: {
                if ("3".equals(kskm)) {
                    if (StringUtils.isEmpty(esDrvpreasignDownLoad.getKsxl())) {
                        esDrvpreasignDownLoad.setKsxl((String)ksxlMaps.get(esCarInfo.getCarWayArray()));
                        this.examineeInfoDbAdapter.updateExamineeInfo(esDrvpreasignDownLoad);
                    }
                    if ("48".equals(siteVersion)) {
                        ksxx.setXldm(PropertiesConfig.getProperties("jgksxl"));
                    }
                    else {
                        ksxx.setXldm((String)ksxlMaps.get(esDrvpreasignDownLoad.getKsxl()));
                    }
                    if (!"JILIN".equals(siteVersion) && !"BAOJI".equals(siteVersion)) {
                        ksxx.setKsxl(esDrvpreasignDownLoad.getKsxl());
                        break Label_3016;
                    }
                    try {
                        String sysset193 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2416);
                        if ("1".equals(sysset193)) {
                            String tempKsxl = this.thirdPartHandleService.getLocalKsxl(esDrvpreasignDownLoad, esCarInfo);
                            ksxx.setKsxl(tempKsxl);
                            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "/实际线路ksxl=" + tempKsxl);
                        }
                    }
                    catch (Exception e4) {
                        throw new RspException("1", e4);
                    }
                }
                else if (motorIsLianKao && "XJ_YILI".equals(siteVersion)) {
                    String ksxlTemp2 = new StringBuilder().append(esCarInfo.getWayNo()).toString();
                    if (ksxlTemp2 == null || "".equals(ksxlTemp2)) {
                        throw new RspException("1", "考车未分配线路");
                    }
                    ksxx.setKsxl(ksxlTemp2);
                    String jgxldm = (String)ksxlMaps.get(ksxlTemp2);
                    if (jgxldm == null || "".equals(jgxldm)) {
                        throw new RspException("1", "线路[" + ksxlTemp2 + "]监管线路代码未设置");
                    }
                    ksxx.setXldm(jgxldm);
                    CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "摩考科目二三连考/实际线路ksxl=" + ksxlTemp2 + "/监管线路xldm=" + jgxldm);
                }
            }
            if ("8".equals(siteVersion)) {
                ksxx.setRoadway(esDrvpreasignDownLoad.getKsxl());
            }
            if (esDrvpreasignDownLoad.getExamineePhoto() != null) {
                String kszp = ImageUtils.GetBase64StrByUrl(esDrvpreasignDownLoad.getExamineePhoto());
                if (!"".equals(kszp)) {
                    ksxx.setKszp(kszp);
                }
                else {
                    ksxx.setKszp("");
                }
            }
            else if (esDrvpreasignDownLoad.getSfzPhoto() != null) {
                String kszp = ImageUtils.GetBase64StrByUrl(esDrvpreasignDownLoad.getSfzPhoto());
                if (!"".equals(kszp)) {
                    ksxx.setKszp(kszp);
                }
                else {
                    ksxx.setKszp("");
                }
            }
            if (esDrvpreasignDownLoad.getGatePhoto() != null) {
                String kszp = ImageUtils.GetBase64StrByUrl(esDrvpreasignDownLoad.getGatePhoto());
                if (!"".equals(kszp)) {
                    ksxx.setKsmjzp(kszp);
                }
                else {
                    ksxx.setKsmjzp("");
                }
            }
            if (esDrvpreasignDownLoad.getJdxx() != null) {
                ksxx.setJdxx(esDrvpreasignDownLoad.getJdxx());
            }
            ksxx.setKsy1(esDrvpreasignDownLoad.getKsy2());
            ksxx.setKsy1sfzmhm(esDrvpreasignDownLoad.getKsy1());
            ksxx.setLsh(esDrvpreasignDownLoad.getLsh());
            ksxx.setZkzmbh(esDrvpreasignDownLoad.getZkzmbh());
            ksxx.setSfzmhm(esDrvpreasignDownLoad.getSfzmhm());
            ksxx.setXb(esDrvpreasignDownLoad.getXb());
            ksxx.setKslx(esDrvpreasignDownLoad.getKsyy());
            ksxx.setKscx(esDrvpreasignDownLoad.getKscx());
            ksxx.setKssycs(new StringBuilder().append(esDrvpreasignDownLoad.getKssycs()).toString());
            ksxx.setKchp(esDrvpreasignDownLoad.getCarCode());
            ksxx.setKszt(new StringBuilder().append(esDrvpreasignDownLoad.getKszt()).toString());
            ksxx.setXh(new StringBuilder().append(esDrvpreasignDownLoad.getXh()).toString());
            ksxx.setZwxx1(esDrvpreasignDownLoad.getFinger1());
            ksxx.setZwxx2(esDrvpreasignDownLoad.getFinger2());
            ksxx.setZwxx3(esDrvpreasignDownLoad.getFinger3());
            if (!"10".equals(siteVersion)) {
                ksxx.setZwxx4(esDrvpreasignDownLoad.getFinger4());
            }
            ksxx.setFieldid("");
            ksxx.setBz1("0,0,");
            ksxx.setYycs(new StringBuilder().append(esDrvpreasignDownLoad.getYycs()).toString());
            ksxx.setSfcode(esDrvpreasignDownLoad.getSfcode());
            ksxx.setCzlx(esDrvpreasignDownLoad.getCzlx());
            ksxx.setKsdd(esDrvpreasignDownLoad.getKsdd());
            ksxx.setKskm(kskm);
            if (motorIsLianKao) {
                ksxx.setMotorType(esDrvpreasignDownLoad.getBk9());
            }
            else {
                ksxx.setMotorType(kskm);
            }
            listJg.add(ksxx);
        }
        response.getBody().setKaoShengXinXi(listJg);
        String md5Key = "";
        for (int k = 0; k < listJg.size(); ++k) {
            md5Key = md5Key + ((((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(k)).getLsh() == null) ? "" : ((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(k)).getLsh()) + ((((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(k)).getSfzmhm() == null) ? "" : ((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(k)).getSfzmhm()) + ((((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(k)).getKchp() == null) ? "" : ((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(k)).getKchp()) + ((((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(k)).getKscx() == null) ? "" : ((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(k)).getKscx()) + ((((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(k)).getKsxl() == null) ? "" : ((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(k)).getKsxl()) + ((((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(k)).getKssycs() == null) ? "" : ((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(k)).getKssycs()) + ((((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(k)).getKszt() == null) ? "" : ((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(k)).getKszt()) + ((((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(k)).getXh() == null) ? "" : ((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(k)).getXh());
        }
        response.getHead().setCheckCode(MD5.md5(md5Key));
        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "---end---");
        return (GetExaminationStudentInfoRsp)this.commonMethodDbAdapter.getSuccessResponse(null, response);
    }
    
    public int LocalAssignCarNew(String sysset190, String sysset191, EsCarinfo esCarInfo, GetExaminationStudentInfoRsp response) throws Exception {
        String siteVersion = ConfigParam.SITE_VERSION;
        String dateTime = CommonFileld.formatterYmdNoConnect.format(new Date());
        Long kdid = esCarInfo.getEsExampointdetail().getId();
        String ksdd = esCarInfo.getEsExampointdetail().getCode();
        String kskm = esCarInfo.getEsExampointdetail().getType();
        String kscx = esCarInfo.getCartype();
        String kchp = esCarInfo.getCarcode();
        String carName = esCarInfo.getCarcode() + "(" + esCarInfo.getCarno() + ")";
        int numShangCheSys190 = (int)Integer.valueOf(sysset190);
        int numDengDaiSys191 = (int)Integer.valueOf(sysset191);
        String carType = null;
        try {
            String sysset192 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 358);
            if ("1".equals(sysset192)) {
                carType = this.getCarType(esCarInfo);
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "开启考车分类功能:" + carType);
            }
            else if ("37".equals(siteVersion) && kscx.equals("C2")) {
                carType = this.getCarType(esCarInfo);
            }
        }
        catch (Exception e) {
            throw new RspException("1", e);
        }
        boolean motorIsLianKao = false;
        if ("1".equals(esCarInfo.getEsExampointdetail().getIsMotor())) {
            String sysset193 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2381);
            if ("1".equals(sysset193) || "4".equals(sysset193)) {
                motorIsLianKao = true;
            }
        }
        StringBuilder hql = new StringBuilder();
        hql.append(" from ").append(EsDrvpreasign.class.getName());
        hql.append(" t where t.sfqk = '0' and t.kssycs > 0 and t.flag <> '1'");
        if (carType != null && !"".equals(carType)) {
            hql.append(" and t.carType ='").append(carType).append("'");
        }
        else {
            hql.append(" and t.carType is null");
        }
        if (esCarInfo.getFieldId() != null && !"".equals(esCarInfo.getFieldId())) {
            hql.append(" and t.fieldid = '").append(esCarInfo.getFieldId()).append("'");
            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "开启分区域功能:" + esCarInfo.getFieldId());
        }
        else {
            hql.append(" and (t.fieldid is null or t.fieldid = '')");
        }
        if ("A1".equals(kscx) || "A3".equals(kscx)) {
            hql.append(" and (t.kscx ='A1' or t.kscx='A3')");
        }
        else {
            hql.append(" and t.kscx ='").append(kscx).append("'");
        }
        if (!motorIsLianKao) {
            hql.append(" and t.kskm ='").append(kskm).append("'");
        }
        hql.append(" and t.ksdd ='").append(ksdd).append("'");
        hql.append(" and t.kszt=2 and t.ykrq = to_date('" + dateTime + "','yyyy-MM-dd') order by t.xh,t.xm");
        List<EsDrvpreasign> esDrvpreasignLstDfp = this.examineeInfoDbAdapter.getDrvpreasignInfoListByHQL(hql);
        int numWaitStu = esDrvpreasignLstDfp.size();
        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "待分配numWaitStu=" + numWaitStu);
        if (numWaitStu == 0) {
            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "无待分配考生sql=" + hql.toString());
        }
        else {
            if ("4".equals(siteVersion)) {
                String sysset196 = null;
                String sysset197;
                String sysset198;
                try {
                    sysset197 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2058);
                    sysset198 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2059);
                    sysset196 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2060);
                }
                catch (Exception e3) {
                    throw new RspException("1", e3);
                }
                boolean needUpdateFlag = this.isUpdateCarCount(sysset197, sysset198, numWaitStu);
                if (needUpdateFlag) {
                    numShangCheSys190 = Integer.parseInt(sysset196);
                    numDengDaiSys191 = 0;
                }
            }
            else if ("36".equals(siteVersion) || "1".equals(siteVersion) || "JIAXING_KM3".equals(siteVersion)) {
                String sysset194 = null;
                String sysset195;
                try {
                    sysset195 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2013);
                    sysset194 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2014);
                }
                catch (Exception e2) {
                    throw new RspException("1", e2);
                }
                if (numWaitStu <= (int)Integer.valueOf(sysset195)) {
                    if ("36".equals(siteVersion)) {
                        numDengDaiSys191 = 0;
                    }
                    else if ("1".equals(siteVersion) && "C1".equals(esCarInfo.getCartype())) {
                        numShangCheSys190 = (int)Integer.valueOf(sysset194);
                        numDengDaiSys191 = 0;
                    }
                    else if ("JIAXING_KM3".equals(siteVersion)) {
                        numShangCheSys190 = (int)Integer.valueOf(sysset194);
                        numDengDaiSys191 = 0;
                    }
                }
            }
            int assignNum = numShangCheSys190 + numDengDaiSys191;
            int unFinishExamineeNum = 0;
            hql.setLength(0);
            hql.append(" from ").append(EsDrvpreasign.class.getName());
            hql.append(" t where t.sfqk = '0' and t.kssycs > 0 and t.flag <> '1'");
            hql.append(" and t.kskm ='").append(kskm).append("'");
            hql.append(" and t.carCode ='").append(kchp).append("'");
            hql.append(" and t.kszt in (0,1,2,3,4) and t.ykrq = to_date('" + dateTime + "','yyyy-MM-dd') order by t.xh,t.xm");
            List<EsDrvpreasign> esDrvpreasignLstKswjs = this.examineeInfoDbAdapter.getDrvpreasignInfoListByHQL(hql);
            unFinishExamineeNum = esDrvpreasignLstKswjs.size();
            int assignRealNum = assignNum - unFinishExamineeNum;
            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "本次实际分配人数assignRealNum=" + assignRealNum);
            String sDlr = null;
            if ("60".equals(siteVersion)) {
                if (unFinishExamineeNum > 0) {
                    sDlr = ((EsDrvpreasign)esDrvpreasignLstKswjs.get(0)).getDlr();
                }
                else {
                    sDlr = ((EsDrvpreasign)esDrvpreasignLstDfp.get(0)).getDlr();
                }
            }
            String sysset199 = null;
            if (ConfigParam.SITE_VERSION.contains("tsdd")) {
                sysset199 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2053);
                if (!"0".equals(sysset199)) {
                    int extraNum = this.checkDrvInCarCount(esCarInfo, sysset199);
                    if (extraNum < assignRealNum) {
                        assignRealNum = extraNum;
                        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "启用考车每天考试总人数限制功能，实际分配人数assignRealNum改为" + assignRealNum + ",若有疑问请查看参数2053");
                    }
                }
            }
            String sysset200 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2109);
            if (assignRealNum > 0 && (!"0".equals(sysset200) || unFinishExamineeNum <= 0)) {
                hql.setLength(0);
                hql.append(" from ").append(EsDrvpreasign.class.getName());
                hql.append(" t where t.sfqk = '0' and t.kssycs >0 and t.flag <> '1'");
                if (carType != null && !"".equals(carType)) {
                    hql.append(" and t.carType = '").append(carType).append("'");
                }
                else {
                    hql.append(" and t.carType is null");
                }
                if (esCarInfo.getFieldId() != null && !"".equals(esCarInfo.getFieldId())) {
                    hql.append(" and t.fieldid = '").append(esCarInfo.getFieldId()).append("'");
                }
                if (sDlr != null && !"".equals(sDlr)) {
                    hql.append(" and t.dlr = '").append(sDlr).append("'");
                }
                hql.append(" and t.kscx='").append(kscx).append("'");
                hql.append(" and t.ksdd='").append(ksdd).append("'");
                hql.append(" and t.kskm='").append(kskm).append("'");
                hql.append(" and t.kszt in (2,3,4)");
                hql.append(" and (t.carCode is null or t.carCode='").append(kchp).append("')");
                hql.append(" and t.ykrq = to_date('" + dateTime + "','yyyy-MM-dd')");
                if (siteVersion.contains("SANMING")) {
                    hql.append(" order by t.kscc,t.xh ");
                }
                else {
                    hql.append(" order by t.xh,t.lsh ");
                }
                List<EsDrvpreasign> esDrvpreasignsTemp = null;
                esDrvpreasignsTemp = this.examineeInfoDbAdapter.getDrvpreasignInfoListByHQL(hql);
                if (esDrvpreasignsTemp == null || esDrvpreasignsTemp.isEmpty()) {
                    CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "未查询到符合条件的考生,HQL=" + hql.toString());
                }
                else {
                    String reason = null;
                    Date updateDate = new Date();
                    String sysset201 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2033);
                    int i = 0;
                    while (i < esDrvpreasignsTemp.size()) {
                        if (i >= assignNum) {
                            break;
                        }
                        if ("33".equals(siteVersion) && "0".equals(esCarInfo.getBk1())) {
                            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "考试车暂停更新学员!");
                            break;
                        }
                        EsDrvpreasign drvpreasign = (EsDrvpreasign)esDrvpreasignsTemp.get(i);
                        this.examineeInfoDbAdapter.evict(drvpreasign);
                        reason = null;
                        if ("".equals(drvpreasign.getCarCode()) || drvpreasign.getCarCode() == null) {
                            drvpreasign.setCarCode(kchp);
                            reason = "中心分车:" + drvpreasign.getXm() + "/" + drvpreasign.getSfzmhm() + "/" + kchp + "/kszt=" + drvpreasign.getKszt();
                            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + reason);
                        }
                        else {
                            reason = "中心分车(重复分车):" + drvpreasign.getXm() + "/" + drvpreasign.getSfzmhm() + "/" + drvpreasign.getCarCode() + "/kszt=" + drvpreasign.getKszt();
                            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + reason);
                        }
                        if ("0".equals(ConfigParam.KSY1)) {
                            if (esCarInfo.getMaExaminerInfoByExaminerId() != null) {
                                drvpreasign.setKsy1(esCarInfo.getMaExaminerInfoByExaminerId().getCode());
                            }
                        }
                        else if ("1".equals(ConfigParam.KSY1) && esCarInfo.getPmUser().getSfzmhm() != null) {
                            drvpreasign.setKsy1(esCarInfo.getPmUser().getSfzmhm());
                        }
                        if ("0".equals(ConfigParam.KSY1SFZMHM)) {
                            if (esCarInfo.getMaExaminerInfoByExaminerId() != null) {
                                drvpreasign.setKsy1sfzmhm(esCarInfo.getMaExaminerInfoByExaminerId().getCode());
                                reason = reason + ",考车登录的考试员(安全员)ID号:" + esCarInfo.getMaExaminerInfoByExaminerId().getCode();
                            }
                        }
                        else if ("1".equals(ConfigParam.KSY1SFZMHM) && esCarInfo.getPmUser().getSfzmhm() != null) {
                            drvpreasign.setKsy1sfzmhm(esCarInfo.getPmUser().getSfzmhm());
                            reason = reason + ",考车绑定的考试员(安全员)ID号:" + esCarInfo.getPmUser().getSfzmhm();
                        }
                        if ("3".equals(kskm)) {
                            if (!"1".equals(sysset201) && (drvpreasign.getKsxl() == null || "".equals(drvpreasign.getKsxl()))) {
                                if (!siteVersion.contains("SANMING") || i <= 0) {
                                    this.setRandomKsxl(esCarInfo);
                                }
                                String ksxl_temp = (esCarInfo.getWayNo() == null) ? "" : new StringBuilder().append(esCarInfo.getWayNo()).toString();
                                drvpreasign.setKsxl(ksxl_temp);
                                reason = reason + ",分配线路:" + ksxl_temp;
                                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + drvpreasign.getXm() + "/" + drvpreasign.getSfzmhm() + ",初考线路：" + ksxl_temp);
                            }
                        }
                        else if ("55".equals(siteVersion) && StringUtils.isEmpty(drvpreasign.getZwh())) {
                            this.setDrvZwhForCdsbinfo(esCarInfo, drvpreasign);
                        }
                        drvpreasign.setLastUpdatedDate(updateDate);
                        Boolean updateFlag = Boolean.valueOf(this.examineeInfoDbAdapter.updateExamineeInfo(drvpreasign));
                        if ((boolean)updateFlag) {
                            String sysset202 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2410);
                            if ("1".equals(sysset202)) {
                                this.webOperateLogDbAdapter.saveSuccessLog(reason, "中心分车", "rest");
                            }
                        }
                        else {
                            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + drvpreasign.getXm() + "/更新drvpreasign表出错");
                        }
                        ++i;
                    }
                }
            }
        }
        return numShangCheSys190;
    }
    
    public GetExaminationStudentInfoRsp returnLocalAssignCarNewRsp(int numShangCheSys190, EsCarinfo esCarInfo, GetExaminationStudentInfoRsp response) throws Exception {
        String siteVersion = ConfigParam.SITE_VERSION;
        Long kdid = esCarInfo.getEsExampointdetail().getId();
        String ksdd = esCarInfo.getEsExampointdetail().getCode();
        String kskm = esCarInfo.getEsExampointdetail().getType();
        String kscx = esCarInfo.getCartype();
        String kchp = esCarInfo.getCarcode();
        String carName = esCarInfo.getCarcode() + "(" + esCarInfo.getCarno() + ")";
        StringBuilder hql = new StringBuilder();
        hql.append(" from ").append(EsDrvpreasign.class.getName()).append(" t where t.sfqk = '0' and t.flag <> '1'");
        hql.append(" and t.ksdd='").append(ksdd).append("'");
        hql.append(" and t.kskm='").append(kskm).append("'");
        hql.append(" and t.kszt in (0,1,2,3,4)");
        hql.append(" and t.carCode='").append(kchp).append("'");
        hql.append(" and t.ykrq = trunc(sysdate) order by t.kszt desc,t.xh,t.lsh ");
        List<EsDrvpreasign> esDrvpreasigns = null;
        esDrvpreasigns = this.examineeInfoDbAdapter.getDrvpreasignInfoListByHQL(hql);
        List<KaoShengXinXi> list = new ArrayList();
        if (esDrvpreasigns.size() <= 0) {
            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "本地分车模式：未查询到已分配考生sql=" + hql.toString());
        }
        else {
            String sysset2054 = null;
            String sysset2055 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2039);
            String sysset2056 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2046);
            String sysset2057 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2047);
            sysset2054 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2054);
            if ("1".equals(sysset2054)) {
                String sysset2058 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 900);
                this.writeAssignCarLog(sysset2058, esCarInfo);
            }
            boolean motorIsLianKao = false;
            if ("1".equals(esCarInfo.getEsExampointdetail().getIsMotor())) {
                String sysset2059 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2381);
                if ("1".equals(sysset2059) || "4".equals(sysset2059)) {
                    motorIsLianKao = true;
                }
            }
            Map<String, String> ksxlMaps = new ConcurrentHashMap();
            if ("3".equals(kskm) || motorIsLianKao || siteVersion.contains("JgWay") || siteVersion.contains("GUIZHOU") || siteVersion.equals("8") || siteVersion.equals("18")) {
                ksxlMaps = this.initializationDbAdapter.getKsxlMapsByCache(kdid);
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "监管线路映射：" + ((ksxlMaps == null) ? "无线路" : ksxlMaps.toString()));
            }
            int indexDrv = 0;
            for (EsDrvpreasign drvpreasign : esDrvpreasigns) {
                if (++indexDrv > numShangCheSys190) {
                    break;
                }
                if ("50".equals(siteVersion)) {
                    this.NjRnsbAdd(esCarInfo, drvpreasign);
                }
                if ((byte)drvpreasign.getKszt() < 3) {
                    drvpreasign.setKszt(Byte.valueOf("3"));
                    String sfz = drvpreasign.getSfzmhm();
                    int kszt_before = (byte)drvpreasign.getKszt();
                    int kszt_next = 3;
                    String reMark = kchp;
                    this.webOperateLogDbAdapter.saveShangHaiLog(sfz, kskm, kszt_before, kszt_next, "4", reMark);
                }
                if (StringUtils.isEmpty(drvpreasign.getKsy1())) {
                    if ("0".equals(ConfigParam.KSY1)) {
                        if (esCarInfo.getMaExaminerInfoByExaminerId() != null) {
                            drvpreasign.setKsy1(esCarInfo.getMaExaminerInfoByExaminerId().getCardNo());
                        }
                    }
                    else if ("1".equals(ConfigParam.KSY1) && esCarInfo.getPmUser().getSfzmhm() != null) {
                        drvpreasign.setKsy1(esCarInfo.getPmUser().getSfzmhm());
                    }
                }
                if (StringUtils.isEmpty(drvpreasign.getKsy1sfzmhm())) {
                    if ("0".equals(ConfigParam.KSY1SFZMHM)) {
                        if (esCarInfo.getMaExaminerInfoByExaminerId() != null) {
                            drvpreasign.setKsy1sfzmhm(esCarInfo.getMaExaminerInfoByExaminerId().getCardNo());
                        }
                    }
                    else if ("2".equals(ConfigParam.KSY1SFZMHM)) {
                        if (esCarInfo.getMaExaminerInfoByExaminerId() != null) {
                            drvpreasign.setKsy1sfzmhm(esCarInfo.getMaExaminerInfoByExaminerId().getCode());
                        }
                    }
                    else if ("1".equals(ConfigParam.KSY1SFZMHM) && esCarInfo.getPmUser().getSfzmhm() != null) {
                        drvpreasign.setKsy1sfzmhm(esCarInfo.getPmUser().getSfzmhm());
                    }
                }
                this.examineeInfoDbAdapter.updateExamineeInfo(drvpreasign);
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "数据更新...");
                KaoShengXinXi ksxx = new KaoShengXinXi();
                if ("5".equals(siteVersion)) {
                    ksxx.setXm(SHA.sha(drvpreasign.getKscx() + "_" + drvpreasign.getXh()).substring(2, 12));
                }
                else if ("2".equals(siteVersion)) {
                    ksxx.setXm(drvpreasign.getSfcode());
                }
                else if ("32".equals(siteVersion) && "3".equals(kskm)) {
                    ksxx.setXm(new StringBuilder().append(drvpreasign.getXh1()).toString());
                }
                else {
                    ksxx.setXm(drvpreasign.getXm());
                }
                String xldm = null;
                String ksxlTemp = null;
                if ("3".equals(kskm) || motorIsLianKao || siteVersion.contains("Way") || siteVersion.equals("8")) {
                    ksxlTemp = drvpreasign.getKsxl();
                    if (ksxlTemp == null || "".equals(ksxlTemp)) {
                        this.setRandomKsxl(esCarInfo);
                        ksxlTemp = new StringBuilder().append(esCarInfo.getWayNo()).toString();
                        if (ksxlTemp == null || "".equals(ksxlTemp)) {
                            throw new RspException("1", "线路分配错误001:不可为空");
                        }
                        drvpreasign.setKsxl(ksxlTemp);
                        this.examineeInfoDbAdapter.updateExamineeInfo(drvpreasign);
                    }
                    else if (ConfigParam.SITE_VERSION.contains("GUIZHOU")) {
                        ksxlTemp = (String)ksxlMaps.get(drvpreasign.getKsxl());
                    }
                    if (ksxlTemp == null || "".equals(ksxlTemp)) {
                        throw new RspException("1", "线路分配错误002:不可为空");
                    }
                    if ((byte)drvpreasign.getKssycs() == 2) {
                        ksxx.setKsxl(ksxlTemp);
                    }
                    else if ("0".equals(sysset2057)) {
                        ksxx.setKsxl(ksxlTemp);
                    }
                    else if (!StringUtils.isEmpty(drvpreasign.getKsxl())) {
                        if (drvpreasign.getKsxl().contains(",")) {
                            ksxlTemp = drvpreasign.getKsxl().substring(drvpreasign.getKsxl().indexOf(",") + 1);
                            ksxx.setKsxl(ksxlTemp);
                            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "补考线路ksxl=" + ksxlTemp + "/历史线路=" + drvpreasign.getKsxl());
                        }
                        else {
                            ksxlTemp = this.getKsxl(drvpreasign, sysset2056, (long)kdid);
                            ksxx.setKsxl(ksxlTemp);
                            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "补考线路ksxl=" + ksxlTemp);
                            ksxlTemp = drvpreasign.getKsxl() + "," + ksxlTemp;
                            drvpreasign.setKsxl(ksxlTemp);
                            this.examineeInfoDbAdapter.updateExamineeInfo(drvpreasign);
                        }
                    }
                    else {
                        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "初考线路丢失ksxl=" + ksxlTemp);
                        ksxx.setKsxl(ksxlTemp);
                        drvpreasign.setKsxl(ksxlTemp);
                        this.examineeInfoDbAdapter.updateExamineeInfo(drvpreasign);
                    }
                    if (ksxlMaps == null || "".equals(ksxlMaps)) {
                        xldm = ksxlTemp;
                    }
                    else {
                        xldm = (String)ksxlMaps.get(ksxlTemp);
                    }
                    if (xldm == null || "".equals(xldm)) {
                        ksxx.setXldm(ksxlTemp);
                    }
                    else {
                        ksxx.setXldm(xldm);
                    }
                    if ("8".equals(siteVersion)) {
                        ksxx.setRoadway(ksxlTemp);
                    }
                }
                if ("15-1".equals(siteVersion) || "15-2".equals(siteVersion) || "21".equals(siteVersion) || "49".equals(siteVersion) || "55".equals(siteVersion)) {
                    ksxx.setJxmc(drvpreasign.getZwh());
                }
                else {
                    ksxx.setJxmc(drvpreasign.getDlr());
                }
                if ("15-1".equals(siteVersion) || "15-2".equals(siteVersion)) {
                    ksxx.setXh(drvpreasign.getSfcode());
                }
                else if (drvpreasign.getXh() != null) {
                    ksxx.setXh(new StringBuilder().append(drvpreasign.getXh()).toString());
                }
                else {
                    ksxx.setXh("0");
                }
                if ("1".equals(sysset2055)) {
                    ksxx.setKsy2(drvpreasign.getKsy1sfzmhm());
                    ksxx.setKsy2sfzmhm(drvpreasign.getKsy2sfzmhm());
                }
                else if ("2".equals(sysset2055) && !esCarInfo.getCartype().startsWith("C")) {
                    ksxx.setKsy2sfzmhm(drvpreasign.getKsy1sfzmhm());
                }
                if (motorIsLianKao && StringUtils.isNotBlank(drvpreasign.getBk8())) {
                    ksxx.setKssycs(drvpreasign.getBk8());
                }
                else {
                    ksxx.setKssycs(new StringBuilder().append(drvpreasign.getKssycs()).toString());
                }
                ksxx.setZwxx1(drvpreasign.getFinger1());
                ksxx.setZwxx2(drvpreasign.getFinger2());
                ksxx.setZwxx3(drvpreasign.getFinger3());
                if (!"10".equals(siteVersion)) {
                    ksxx.setZwxx4(drvpreasign.getFinger4());
                }
                String sysset2060 = null;
                if ("3".equals(esCarInfo.getSystemType())) {
                    sysset2060 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2602);
                }
                if (!"1".equals(sysset2060)) {
                    if (drvpreasign.getExamineePhoto() != null) {
                        String kszp = ImageUtils.GetBase64StrByUrl(drvpreasign.getExamineePhoto());
                        if (!"".equals(kszp)) {
                            ksxx.setKszp(kszp);
                        }
                        else {
                            ksxx.setKszp("");
                        }
                    }
                    else if (drvpreasign.getSfzPhoto() != null) {
                        String kszp = ImageUtils.GetBase64StrByUrl(drvpreasign.getSfzPhoto());
                        if (!"".equals(kszp)) {
                            ksxx.setKszp(kszp);
                        }
                        else {
                            ksxx.setKszp("");
                        }
                    }
                    if (drvpreasign.getGatePhoto() != null) {
                        String kszp = ImageUtils.GetBase64StrByUrl(drvpreasign.getGatePhoto());
                        if (!"".equals(kszp)) {
                            ksxx.setKsmjzp(kszp);
                        }
                        else {
                            ksxx.setKsmjzp("");
                        }
                    }
                }
                if (drvpreasign.getJdxx() != null) {
                    ksxx.setJdxx(drvpreasign.getJdxx());
                }
                ksxx.setLsh(drvpreasign.getLsh());
                ksxx.setZkzmbh(drvpreasign.getZkzmbh());
                ksxx.setSfzmhm(drvpreasign.getSfzmhm());
                ksxx.setXb(drvpreasign.getXb());
                ksxx.setKslx(drvpreasign.getKsyy());
                ksxx.setKscx(drvpreasign.getKscx());
                ksxx.setKsy1(drvpreasign.getKsy2());
                ksxx.setKsy1sfzmhm(drvpreasign.getKsy1());
                ksxx.setKchp(drvpreasign.getCarCode());
                ksxx.setKszt(new StringBuilder().append(drvpreasign.getKszt()).toString());
                ksxx.setSfcode(drvpreasign.getSfcode());
                ksxx.setFieldid("");
                ksxx.setBz1("0,0,");
                if (motorIsLianKao) {
                    ksxx.setMotorType(drvpreasign.getBk9());
                    CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "连考模式，MotorType(bk9)=" + drvpreasign.getBk9());
                }
                else {
                    ksxx.setMotorType(kskm);
                    CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "非连考模式，MotorType=" + kskm);
                }
                ksxx.setCzlx(drvpreasign.getCzlx());
                ksxx.setYycs(new StringBuilder().append(drvpreasign.getYycs()).toString());
                ksxx.setKsdd(drvpreasign.getKsdd());
                ksxx.setKskm(kskm);
                if ("35".equals(siteVersion)) {
                    String sj = CommonFileld.formatterYmd.format(drvpreasign.getKsrq());
                    String code = HeZhouWebServiceClient.uploadCheckedPhoto(esCarInfo.getEsExampointdetail().getId().toString(), kskm, ksxx.getKsmjzp(), drvpreasign.getSfzmhm(), sj, esCarInfo.getCarno());
                    if (!"1".equals(code)) {
                        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "上传门禁考前报到照片结果失败");
                    }
                    int todayFinishCount2 = this.examineeInfoDbAdapter.getFinishExamineeNum(esCarInfo.getEsExampointdetail().getCode(), CommonFileld.formatterYmdNoConnect.format(drvpreasign.getKsrq()), esCarInfo.getCarcode(), esCarInfo.getEsExampointdetail().getType());
                    CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "该车辆考完人数+" + todayFinishCount2);
                    String code2 = HeZhouWebServiceClient.uploadFCRS(esCarInfo.getCarcode(), kskm, todayFinishCount2);
                    if (!"1".equals(code2)) {
                        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "考试分车信息上传结果失败");
                    }
                }
                if ("46".equals(siteVersion)) {
                    String sysset2061 = null;
                    String sysset2062 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 901);
                    sysset2061 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 902);
                    String kssj = CommonFileld.formatterYmdHms.format(new Date());
                    String code3 = HeChiWebServiceClient.writeObject(ksxx.getLsh(), kskm, sysset2061, drvpreasign.getSfzmhm(), drvpreasign.getKsy1sfzmhm(), ksxx.getKsmjzp(), kssj, drvpreasign.getKsy2sfzmhm(), esCarInfo.getCarno(), sysset2062, kchp);
                    if (!"1".equals(code3)) {
                        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "身份信息比对写入结果失败");
                    }
                }
                list.add(ksxx);
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "下放考生:" + drvpreasign.getXm() + "/" + drvpreasign.getSfzmhm() + "/kskm=" + drvpreasign.getKskm() + "/ksxl=" + drvpreasign.getKsxl() + "/xldm=" + xldm + "/kszt=" + drvpreasign.getKszt() + "/ksy1=" + drvpreasign.getKsy1());
            }
        }
        if (list.isEmpty()) {
            throw new RspException("1", "该车辆暂时没有考生");
        }
        response.getBody().setKaoShengXinXi(list);
        String md5Key = "";
        for (int i = 0; i < list.size(); ++i) {
            md5Key = md5Key + ((((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(i)).getLsh() == null) ? "" : ((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(i)).getLsh()) + ((((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(i)).getSfzmhm() == null) ? "" : ((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(i)).getSfzmhm()) + ((((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(i)).getKchp() == null) ? "" : ((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(i)).getKchp()) + ((((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(i)).getKscx() == null) ? "" : ((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(i)).getKscx()) + ((((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(i)).getKsxl() == null) ? "" : ((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(i)).getKsxl()) + ((((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(i)).getKssycs() == null) ? "" : ((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(i)).getKssycs()) + ((((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(i)).getKszt() == null) ? "" : ((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(i)).getKszt()) + ((((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(i)).getXh() == null) ? "" : ((KaoShengXinXi)response.getBody().getKaoShengXinXi().get(i)).getXh());
        }
        response.getHead().setCheckCode(MD5.md5(md5Key));
        return (GetExaminationStudentInfoRsp)this.commonMethodDbAdapter.getSuccessResponse(null, response);
    }
    
    public void NjRnsbAdd(EsCarinfo esCarInfo, EsDrvpreasign drvpreasign) {
        EsDrvpreasign drvpreasignFinal = drvpreasign;
        EsCarinfo esCarinfoFinal = esCarInfo;
        SupervisePool.getInstance().execute(new CarDownloadStuInfoService.CarDownloadStuInfoService$1(this, drvpreasignFinal, esCarinfoFinal));
    }
    
    public boolean setRandomKsxl(EsCarinfo esCarInfo) throws Exception {
        Long examinationRoomId = esCarInfo.getEsExampointdetail().getId();
        EsExampointway esExampointway = null;
        try {
            esExampointway = this.examTimeDbAdapter.getExamPointWay((long)examinationRoomId, esCarInfo.getCartype());
        }
        catch (Exception e) {
            throw new RspException("1", e);
        }
        if (esExampointway == null || esExampointway.getExamway() == null || "".equals(esExampointway.getExamway())) {
            throw new RspException("1", "未查询到线路[esExampointway]!");
        }
        String[] way = esExampointway.getExamway().split(",");
        if (way.length == 1) {
            esCarInfo.setWayNo(Integer.valueOf(Integer.parseInt(way[0])));
            this.carExamInfoDbAdapter.updateCarInfo(esCarInfo);
            return true;
        }
        String sysset2118 = null;
        String sysset2119;
        try {
            sysset2119 = this.initializationDbAdapter.queryMaSyssetByCache(examinationRoomId, 2062);
            sysset2118 = this.initializationDbAdapter.queryMaSyssetByCache(examinationRoomId, 2118);
        }
        catch (Exception e2) {
            throw new RspException("1", e2);
        }
        if (!"0".equals(sysset2118)) {
            ArrayList<String> ksxlOnceList = new ArrayList();
            HashMap<String, Integer> ksxlOnceMap = this.examineeInfoDbAdapter.getKsxlCountByDrv(esCarInfo.getEsExampointdetail().getCode(), esCarInfo.getEsExampointdetail().getType(), esCarInfo.getCartype());
            HashMap<String, Integer> ksxlParamMap = this.getKsxlParamMap(sysset2118);
            for (String wayTemp : way) {
                Integer ksxlOnce = Integer.valueOf((ksxlOnceMap.get(wayTemp) == null) ? 0 : ((int)ksxlOnceMap.get(wayTemp)));
                Integer ksxlParam = Integer.valueOf((ksxlParamMap.get(wayTemp) == null) ? 0 : ((int)ksxlParamMap.get(wayTemp)));
                if ((int)ksxlOnce <= (int)ksxlParam) {
                    ksxlOnceList.add(wayTemp);
                }
            }
            if (ksxlOnceList == null || ksxlOnceList.size() <= 0) {
                throw new RspException("1", "所有考试线路已分配完毕");
            }
            String[] ksxlArray = new String[ksxlOnceList.size()];
            way = (String[])ksxlOnceList.toArray(ksxlArray);
        }
        if ("0".equals(sysset2119)) {
            Random rand = new Random();
            esCarInfo.setWayNo(Integer.valueOf(Integer.parseInt(way[rand.nextInt(way.length)])));
        }
        else {
            int ksxlRet = this.carExamInfoDbAdapter.getAvgRandomKsxml((long)examinationRoomId, esCarInfo.getCartype(), way);
            esCarInfo.setWayNo(Integer.valueOf(ksxlRet));
        }
        boolean flag = this.carExamInfoDbAdapter.updateCarInfo(esCarInfo);
        if (!flag) {
            throw new RspException("1", "更新考车数据失败!");
        }
        return true;
    }
    
    public int GuilinJingYingAssignCar(String sysset190, EsCarinfo esCarInfo) {
        Long examPointdetailId = esCarInfo.getEsExampointdetail().getId();
        String sysset191 = null;
        String sysset192;
        try {
            sysset192 = this.initializationDbAdapter.queryMaSyssetByCache(examPointdetailId, 358);
            sysset191 = this.initializationDbAdapter.queryMaSyssetByCache(examPointdetailId, 2036);
        }
        catch (Exception e) {
            throw new RspException("1", e);
        }
        int totalExamineeNum = (int)Integer.valueOf(sysset190);
        String dateTime = CommonFileld.formatterYmdNoConnect.format(new Date());
        String carType = null;
        if ("1".equals(sysset192)) {
            carType = this.getCarType(esCarInfo);
        }
        int allotExamineeNum;
        try {
            allotExamineeNum = this.examineeInfoDbAdapter.getUnExamExamineeNum(esCarInfo.getEsExampointdetail().getCode(), dateTime, carType, esCarInfo.getFieldId(), esCarInfo.getEsExampointdetail().getType());
        }
        catch (Exception e2) {
            throw new RspException("1", e2);
        }
        int realReqNum = totalExamineeNum;
        if (allotExamineeNum < totalExamineeNum) {
            realReqNum = allotExamineeNum;
        }
        int unFinishExamineeNum = 0;
        try {
            unFinishExamineeNum = this.examineeInfoDbAdapter.getUnFinishedExamineeNum(esCarInfo.getEsExampointdetail().getCode(), esCarInfo.getCarcode(), "'3','4','5'", esCarInfo.getEsExampointdetail().getType());
        }
        catch (Exception e3) {
            throw new RspException("1", e3);
        }
        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "allotExamineeNum待考人数:" + allotExamineeNum + ";realReqNum请求人数:" + realReqNum + ";是否可以更新:" + unFinishExamineeNum);
        unFinishExamineeNum = 0;
        if (unFinishExamineeNum == 0) {
            this.thirdPartHandleService.sendThirdPartWriteObjectOutForGuilinAssignCar(realReqNum, sysset191, esCarInfo);
        }
        return totalExamineeNum;
    }
    
    public String getCarType(EsCarinfo esCarInfo) {
        String carType = null;
        if (esCarInfo.getEsCarType() == null || esCarInfo.getEsCarType().getTypeName() == null || "".equals(esCarInfo.getEsCarType().getTypeName())) {
            return carType;
        }
        carType = esCarInfo.getEsCarType().getTypeName();
        if ("shanghai".equals(ConfigParam.SITE_VERSION)) {
            carType = carType.substring(0, carType.length() - 1);
        }
        else if (carType.endsWith("1")) {
            carType = carType.split("1")[0];
        }
        return carType;
    }
    
    public void checkKgStartExaminee(String sysset2303, long kdid) {
        if ("6".equals(ConfigParam.SITE_VERSION)) {
            String currentTime = null;
            currentTime = CommonFileld.formatterYmdNoConnect.format(new Date());
            Date d = null;
            try {
                d = CommonFileld.formatterYmdHms.parse(sysset2303);
            }
            catch (ParseException e4) {
                throw new RspException("1", "考官确认的考试开始时间格式为yyyy-MM-dd HH:mm:ss");
            }
            String newTime = CommonFileld.formatterYmdNoConnect.format(d);
            if (!currentTime.equals(newTime)) {
                throw new RspException("1", "考官还未确认");
            }
        }
        else if ("2-2".equals(ConfigParam.SITE_VERSION)) {
            try {
                Date kskssj = CommonFileld.formatterYmdHms.parse(sysset2303);
                Date today = CommonFileld.formatterYmd.parse(CommonFileld.formatterYmd.format(new Date()));
                if (kskssj.before(today) || kskssj.after(new Date())) {
                    throw new RspException("1", "考官未确认开始考试");
                }
            }
            catch (Exception e) {
                throw new RspException("1", e);
            }
        }
        else if (ConfigParam.SITE_VERSION.contains("SHANGRAO") || "37".equals(ConfigParam.SITE_VERSION)) {
            String sysset2304 = null;
            String sysset2305;
            try {
                sysset2305 = this.initializationDbAdapter.queryMaSyssetByCache(Long.valueOf(kdid), 2900);
                sysset2304 = this.initializationDbAdapter.queryMaSyssetByCache(Long.valueOf(kdid), 2902);
            }
            catch (Exception e2) {
                throw new RspException("1", e2);
            }
            String isShangraoTimeControl = sysset2305;
            if ("1".equals(isShangraoTimeControl)) {
                try {
                    SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd");
                    SimpleDateFormat format2 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                    SimpleDateFormat format3 = new SimpleDateFormat("yyyy-MM-dd HH:mm");
                    String today2 = format1.format(new Date());
                    StringBuilder builder = new StringBuilder();
                    builder.append("select to_char(t.time,'yyyy-mm-dd hh24:mi:ss') from MA_EXAM_TIME_CONTROL t where t.type in ('1','3') and t.time>to_date('").append(today2).append("','yyyy-mm-dd')  and t.check_result='1' and exampoint_id=").append(kdid);
                    Object startTimeObj = this.examineeInfoDbAdapter.getMyobjectBySql(builder);
                    if (startTimeObj == null) {
                        String message2 = "此考场[" + kdid + "]未申请开考，不允许考试";
                        CarDownloadStuInfoService.LOGGER.info(message2);
                        throw new RspException("1", message2);
                    }
                    String timeControlEndTime = sysset2304;
                    Date endTime = format3.parse(today2 + " " + timeControlEndTime);
                    StringBuilder builder2 = new StringBuilder();
                    builder2.append("select to_char(t.time,'yyyy-mm-dd hh24:mi:ss') from MA_EXAM_TIME_CONTROL t where t.type = '4' and t.time>to_date('").append(today2).append("','yyyy-mm-dd')  and t.check_result='1' ");
                    Object endTimeObj1 = this.examineeInfoDbAdapter.getMyobjectBySql(builder2);
                    if (endTimeObj1 != null) {
                        endTime = format2.parse(endTimeObj1.toString());
                    }
                    else {
                        StringBuilder builder3 = new StringBuilder();
                        builder3.append("select to_char(t.time,'yyyy-mm-dd hh24:mi:ss') from MA_EXAM_TIME_CONTROL t where t.type = '2' and t.time>to_date('").append(today2).append("','yyyy-mm-dd')  and t.check_result='1' ");
                        Object endTimeObj2 = this.examineeInfoDbAdapter.getMyobjectBySql(builder3);
                        if (endTimeObj2 != null) {
                            endTime = format2.parse(endTimeObj2.toString());
                        }
                    }
                    if (new Date().after(endTime)) {
                        String message = "已超过此考场[" + kdid + "]结束时间" + format2.format(endTime) + "，不允许考试";
                        CarDownloadStuInfoService.LOGGER.info(message);
                        throw new RspException("1", message);
                    }
                }
                catch (Exception e3) {
                    throw new RspException("1", e3);
                }
            }
        }
        else {
            if (StringUtils.isBlank(sysset2303)) {
                throw new RspException("1", "考官未确认开始考试");
            }
            try {
                Date kskssj = CommonFileld.formatterYmdHms.parse(sysset2303);
                Date today = CommonFileld.formatterYmd.parse(CommonFileld.formatterYmd.format(new Date()));
                if (kskssj.before(today) || kskssj.after(new Date())) {
                    throw new RspException("1", "考官未确认开始考试");
                }
            }
            catch (Exception e) {
                throw new RspException("1", e);
            }
        }
    }
    
    public int checkDrvInCarCount(EsCarinfo esCarInfo, String sysset2053) throws Exception {
        String ksdd = esCarInfo.getEsExampointdetail().getCode();
        String kchp = esCarInfo.getCarcode();
        int carDrvCount = 0;
        if ("1".equals(sysset2053)) {
            carDrvCount = this.examineeInfoDbAdapter.getInCarDrvCount(ksdd, kchp, "'1','2','3','4','5'");
        }
        else if ("2".equals(sysset2053)) {
            carDrvCount = this.examineeInfoDbAdapter.getInCarDrvCount(ksdd, kchp, "5");
        }
        int extraNum = 0;
        if ("1".equals(sysset2053) || "2".equals(sysset2053)) {
            StringUtils.isEmpty(esCarInfo.getBk2());
            if (Integer.parseInt(esCarInfo.getBk2()) < carDrvCount) {
                throw new RspException("1", "考车当天考试人数超过其限定人数");
            }
            extraNum = Integer.parseInt(esCarInfo.getBk2()) - carDrvCount;
            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + kchp + "已考人数Count=" + carDrvCount + "/上限人数Count=" + esCarInfo.getBk2());
            return extraNum;
        }
        else {
            return 10000;
        }
    }
    
    public void checkSignCountforSiteVersion44(EsCarinfo esCarInfo) {
        int drvHasSigncount = this.examineeInfoDbAdapter.findDrvcountByksztsAndKsddAndKscc("'1','2','3','4','5'", esCarInfo.getEsExampointdetail().getCode(), null, esCarInfo.getEsExampointdetail().getType());
        int useCarCount = this.carExamInfoDbAdapter.getCarCountByKdid((long)esCarInfo.getEsExampointdetail().getId());
        if ("2".equals(esCarInfo.getEsExampointdetail().getType())) {
            useCarCount *= 5;
        }
        if ("3".equals(esCarInfo.getEsExampointdetail().getType())) {
            useCarCount *= 4;
        }
        if (useCarCount > drvHasSigncount) {
            throw new RspException("1", "已签到人数必须大于考车数4倍或5倍");
        }
        return;
    }
    
    public void checkInExamTime(long examinationRoomId) {
        boolean flag = false;
        try {
            flag = this.examTimeDbAdapter.isInExamTime(examinationRoomId);
        }
        catch (Exception e) {
            throw new RspException("1", e);
        }
        if (!flag) {
            throw new RspException("1", "不在考试时间!");
        }
        return;
    }
    
    public EsCarinfo getEsCarinfoAndCheckCar(long carId) {
        EsCarinfo esCarInfo = null;
        try {
            esCarInfo = this.carExamInfoDbAdapter.getCarInfoByCarId(carId);
            if (esCarInfo == null) {
                throw new RspException("1", "未查询到考车");
            }
            if (esCarInfo.getEsExampointdetail() == null || esCarInfo.getEsExampointdetail().getCode() == null || "".equals(esCarInfo.getEsExampointdetail().getCode()) || esCarInfo.getEsExampointdetail().getType() == null || "".equals(esCarInfo.getEsExampointdetail().getType())) {
                throw new RspException("1", "ID值为" + carId + "的carinfo表考点数据异常！");
            }
            String carName = esCarInfo.getCarcode() + "(" + esCarInfo.getCarno() + ")";
            EsCheckCar esCheckCar = null;
            try {
                esCheckCar = this.carExamInfoDbAdapter.getCheckCarInfo((long)esCarInfo.getEsExampointdetail().getId(), esCarInfo.getCarcode(), esCarInfo.getCarno(), CommonFileld.formatterYmdNoConnect.format(new Date()));
            }
            catch (Exception e) {
                throw new RspException("1", "查询ES_CHECK_CAR表错误：" + e);
            }
            if (esCheckCar != null && ("1".equals(esCheckCar.getStatus()) || "3".equals(esCheckCar.getStatus()))) {
                throw new RspException("1", "考车未自检或自检未通过");
            }
            String cardNoTemp = esCarInfo.getCardNoArray();
            if (cardNoTemp != null) {
                String sysset2109 = this.initializationDbAdapter.queryMaSyssetByCache(esCarInfo.getEsExampointdetail().getId(), 2109);
                if ("0".equals(sysset2109)) {
                    List<EsDrvpreasign> esDrvpreasignsTemp = null;
                    StringBuilder HQL = new StringBuilder();
                    HQL.append(" from ").append(EsDrvpreasign.class.getName());
                    HQL.append(" t where (t.sfqk='1' or t.flag='1' or t.kszt=5) and t.carCode='").append(esCarInfo.getCarcode()).append("' and t.ykrq = trunc(sysdate) order by t.xh");
                    esDrvpreasignsTemp = this.examineeInfoDbAdapter.getDrvpreasignInfoListByHQL(HQL);
                    if (esDrvpreasignsTemp != null && !esDrvpreasignsTemp.isEmpty()) {
                        for (int indexJg = 0; indexJg < esDrvpreasignsTemp.size(); ++indexJg) {
                            EsDrvpreasign esDrvpreasignDownLoad = (EsDrvpreasign)esDrvpreasignsTemp.get(indexJg);
                            if (cardNoTemp.indexOf(esDrvpreasignDownLoad.getSfzmhm()) != -1) {
                                cardNoTemp = cardNoTemp.replace(esDrvpreasignDownLoad.getSfzmhm(), "");
                                if (cardNoTemp.contains(",")) {
                                    cardNoTemp = cardNoTemp.replaceAll(",+", ",");
                                    cardNoTemp = cardNoTemp.replaceAll(",$", "");
                                    cardNoTemp = cardNoTemp.replaceAll("^,", "");
                                }
                                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "考生:" + esDrvpreasignDownLoad.getXm() + "/" + esDrvpreasignDownLoad.getSfzmhm() + "考试完成/cardNoTemp=" + cardNoTemp);
                            }
                        }
                        esCarInfo.setCardNoArray(cardNoTemp);
                        this.carExamInfoDbAdapter.updateCarInfo(esCarInfo);
                    }
                    esCarInfo = this.carExamInfoDbAdapter.getCarInfoByCarId(carId);
                }
            }
        }
        catch (Exception e2) {
            throw new RspException("1", e2);
        }
        return esCarInfo;
    }
    
    public Long getJgAssignKscc(EsCarinfo esCarInfo, String kskm, String sysset2045) {
        Long kscc = Long.valueOf(12345L);
        Long kdid = esCarInfo.getEsExampointdetail().getId();
        String carName = esCarInfo.getCarcode() + "(" + esCarInfo.getCarno() + ")";
        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "sysset2045=" + sysset2045);
        if ("0".equals(sysset2045)) {
            List<Object> ksccs = null;
            try {
                ksccs = this.examTimeDbAdapter.findKsccByDate(kdid, CommonFileld.formatterHm.format(new Date()));
            }
            catch (Exception e2) {
                throw new RspException("1", carName + "获取场次失败,查询场次时间表错误" + e2);
            }
            if (ksccs == null || ksccs.size() == 0) {
                throw new RspException("1", carName + "获取场次失败,未查询到该时间段的考试场次,请查看der2部署说明书场次配置说明！");
            }
            if (ksccs.size() > 1) {
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "考试场次时间配置重叠");
                kscc = Long.valueOf(((Number)ksccs.get(0)).longValue());
            }
            else {
                kscc = Long.valueOf(((Number)ksccs.get(0)).longValue());
            }
        }
        else if ("1".equals(sysset2045)) {
            String tempstr = null;
            try {
                tempstr = esCarInfo.getKscc().toString();
                if (StringUtils.isNotEmpty(tempstr)) {
                    kscc = esCarInfo.getKscc();
                }
                else {
                    throw new RspException("1", carName + "获取场次失败,考车未绑定考试场次，请查看监管部署说明1.4.3章");
                }
            }
            catch (Exception e2) {
                throw new RspException("1", carName + "获取场次失败,获取考车考试场次值错误，请查看监管部署说明1.4.3章" + e2);
            }
        }
        else if ("2".equals(sysset2045)) {
            String ksdd = esCarInfo.getEsExampointdetail().getCode();
            SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMdd");
            List<EsDrvpreasign> esDrvpreasignsTemp = null;
            StringBuilder HQL = new StringBuilder();
            HQL.append(" from ").append(EsDrvpreasign.class.getName());
            HQL.append(" t where t.sfqk<>'1' and t.kssycs >0 and t.kszt in(2,3,4) ");
            if ("1".equals(ConfigParam.SITE_VERSION)) {
                String fieldid = this.getZjClppToArea(esCarInfo.getEsCarType().getTypeName());
                if (fieldid == null || "".equals(fieldid)) {
                    throw new RspException("1", carName + "根据分区值获取场次失败，请检查config文件ClppToArea配置");
                }
                HQL.append(" and t.fieldid='").append(fieldid).append("'");
            }
            else if (ConfigParam.SITE_VERSION.contains("FOSHAN") || "41".equals(ConfigParam.SITE_VERSION)) {
                String kscclist2 = null;
                String sysset2046;
                try {
                    sysset2046 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2107);
                }
                catch (Exception e) {
                    throw new RspException("1", e);
                }
                kscclist2 = this.getFsKsccByFieldid(esCarInfo.getFieldId(), sysset2046);
                HQL.append(" and t.kscc in (").append(kscclist2).append(")");
            }
            else if ("WENZHOU".equals(ConfigParam.SITE_VERSION) || "36".equals(ConfigParam.SITE_VERSION)) {
                String kscclist = esCarInfo.getFieldId();
                HQL.append(" and t.kscc in (").append(kscclist).append(")");
            }
            if ("A1".equals(esCarInfo.getCartype()) || "A3".equals(esCarInfo.getCartype())) {
                HQL.append(" and (t.kscx='A1' or t.kscx='A3')");
            }
            else {
                HQL.append(" and t.kscx='").append(esCarInfo.getCartype()).append("'");
            }
            HQL.append(" and t.ksdd='").append(ksdd).append("'");
            HQL.append(" and t.kskm='").append(kskm).append("'");
            HQL.append(" and (t.carCode is null or t.carCode='").append(esCarInfo.getCarcode()).append("')");
            HQL.append(" and t.ykrq = to_date('" + formatter.format(new Date()) + "','yyyy-MM-dd')");
            if (ConfigParam.SITE_VERSION.contains("TAIAN")) {
                HQL.append(" order by t.carCode,t.kszt desc,t.kscc,t.xh");
            }
            else {
                HQL.append(" order by t.carCode,t.kszt desc,t.xh");
            }
            if ("1".equals(ConfigParam.TEST_MODE)) {
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "自动获取场次:" + HQL.toString());
            }
            esDrvpreasignsTemp = this.examineeInfoDbAdapter.getDrvpreasignInfoListByHQL(HQL);
            if (esDrvpreasignsTemp == null || esDrvpreasignsTemp.isEmpty()) {
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "自动获取场次失败,无待分配考生,sql语句：" + HQL.toString());
                throw new RspException("1", carName + "获取场次失败,请核对是否还有待分配考生！");
            }
            kscc = Long.valueOf((long)((EsDrvpreasign)esDrvpreasignsTemp.get(0)).getKscc());
        }
        else {
            "3".equals(sysset2045);
        }
        return kscc;
    }
    
    private boolean isUpdateCarCount(String sysset2058, String sysset2059, int allotExamineeNum) {
        String[] setTimes = sysset2058.split(":");
        Calendar cal = Calendar.getInstance();
        cal.set(11, Integer.parseInt(setTimes[0]));
        cal.set(12, Integer.parseInt(setTimes[1]));
        cal.set(13, Integer.parseInt(setTimes[2]));
        Long setTime = Long.valueOf(cal.getTimeInMillis());
        Long currentTime = Long.valueOf(System.currentTimeMillis());
        return (long)currentTime > (long)setTime && allotExamineeNum <= Integer.parseInt(sysset2059);
    }
    
    private void setDrvZwhForCdsbinfo(EsCarinfo esCarInfo, EsDrvpreasign drvpreasign) {
        List<MaCdsbinfo> maCdsbinfos = this.initializationDbAdapter.getMaCdsbinfoByKdIdAndKsxmsm(esCarInfo.getEsExampointdetail().getId(), esCarInfo.getEsExampointdetail().getCode(), "倒车入库");
        List<MaCdsbinfo> ranMaCdsbinfos = new ArrayList();
        ranMaCdsbinfos.add((MaCdsbinfo)maCdsbinfos.get(0));
        for (int cdsbInfoindex = 0; cdsbInfoindex < maCdsbinfos.size() && ((MaCdsbinfo)maCdsbinfos.get(0)).readCount() == ((MaCdsbinfo)maCdsbinfos.get(cdsbInfoindex)).readCount(); ++cdsbInfoindex) {
            ranMaCdsbinfos.add((MaCdsbinfo)maCdsbinfos.get(cdsbInfoindex));
        }
        int indexTemp = new Random().nextInt(ranMaCdsbinfos.size());
        drvpreasign.setZwh(((MaCdsbinfo)ranMaCdsbinfos.get(indexTemp)).getItemsno());
    }
    
    private HashMap<String, Integer> getKsxlParamMap(String param) {
        HashMap<String, Integer> ksxlParamMap = new HashMap();
        for (String ksxlOnce : param.split(";")) {
            String[] ksxlTemp = ksxlOnce.split(":");
            ksxlParamMap.put(ksxlTemp[0], Integer.valueOf(Integer.parseInt(ksxlTemp[1])));
        }
        return ksxlParamMap;
    }
    
    private void writeAssignCarLog(String sysset900, EsCarinfo esCarInfo) {
        ExecutorService threadPoolExecutor = SupervisePool.getInstance();
        Runnable runnable = new CarDownloadStuInfoService.CarDownloadStuInfoService$2(this, sysset900, esCarInfo);
        threadPoolExecutor.execute(runnable);
    }
    
    private void CheckWaitStuInfoCount(EsCarinfo esCarInfo, String sysset2405) throws Exception {
        String dateTime = CommonFileld.formatterYmdNoConnect.format(new Date());
        String ksdd = esCarInfo.getEsExampointdetail().getCode();
        int numZ = Integer.parseInt(sysset2405);
        int numNoShangChe = 0;
        try {
            numNoShangChe = this.examineeInfoDbAdapter.getUnExamExamineeNum(ksdd, dateTime, null, esCarInfo.getFieldId(), esCarInfo.getEsExampointdetail().getType());
        }
        catch (Exception e) {
            throw new RspException("1", e);
        }
        if (numNoShangChe < numZ) {
            StringBuilder sql = new StringBuilder();
            sql.append(" select count(1) from ES_DRVPREASIGN t where t.ksdd='" + ksdd + "' and t.sfqk = '0' and t.kscx='" + esCarInfo.getCartype() + "' and t.kszt=0 and t.ykrq = trunc(sysdate)");
            int num = this.examineeInfoDbAdapter.getMyIntegerValue(sql);
            if (num > 0) {
                String sMsg = "当前待分配考生少于" + numZ + "人，还有" + num + "人未签到，请继续签到！";
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + sMsg);
                throw new RspException("1", sMsg);
            }
        }
    }
    
    public int checkStatusGoodCarNum(Long kdid) throws Exception {
        String date = CommonFileld.formatterYmd.format(new Date());
        StringBuilder sql = new StringBuilder();
        sql.append("select count(1) from ES_CHECK_CAR_LOG t where (t.status='2' or t.status='Y') and t.kdid =").append(kdid).append(" and t.check_date >= to_date('" + date + "','yyyy-MM-dd') ");
        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "考车自检数量查询" + sql.toString());
        int count = this.examineeInfoDbAdapter.getMyIntegerValue(sql);
        return count;
    }
    
    public String getWays(EsExampointway esExampointway2, String sysset2046) {
        String sjxl = null;
        String[] way = esExampointway2.getExamway().split(",");
        int waylen = way.length;
        String[] way2 = sysset2046.split(",");
        int sum = 0;
        for (int k = 0; k < way2.length; ++k) {
            sum += Integer.parseInt(way2[k]);
        }
        if (sum == 10) {
            ArrayList<String> list2 = new ArrayList();
            for (int i = 0; i < way.length; ++i) {
                for (int j = 0; j < Integer.parseInt(way2[i]); ++j) {
                    list2.add(way[i]);
                }
            }
            way = (String[])list2.toArray(new String[list2.size()]);
            Random rand = new Random();
            sjxl = way[rand.nextInt(way.length)];
        }
        StringBuilder sXML = new StringBuilder();
        sXML.append("select count(*) as sl, bk9 from es_drvpreasign where bk9 is not null and ykrq=trunc(sysdate) group by bk9 order by sl,bk9");
        List<Object[]> objList = this.examineeInfoDbAdapter.getMyobjectListBySql(sXML);
        if (objList.size() > 0) {
            Object[] obj = (Object[])objList.get(0);
            String sjxlFirst = new StringBuilder().append(obj[1]).toString();
            String ksxlTemp = ",";
            for (int l = 0; l < objList.size(); ++l) {
                ksxlTemp = ksxlTemp + ((Object[])objList.get(l))[1] + ",";
            }
            if (waylen == objList.size()) {
                int num2 = 0;
                int num3 = Integer.parseInt(((Object[])objList.get(0))[1].toString());
                num2 = Integer.parseInt(((Object[])objList.get(objList.size() - 1))[1].toString());
                if (num2 - num3 > 3) {
                    sjxl = sjxlFirst;
                }
            }
            else {
                int l = 0;
                while (l < way.length) {
                    if (!ksxlTemp.contains(way[l])) {
                        sjxl = way[l];
                        break;
                    }
                    ++l;
                }
            }
        }
        if (sjxl == null || sjxl.isEmpty()) {
            sjxl = way[0];
            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "随机线路出现错误");
            return sjxl;
        }
        return sjxl;
    }
    
    public String getKsxl(EsDrvpreasign drvpreasign, String sysset2046, long kdid) throws Exception {
        String ksxl = null;
        EsExampointway esExampointway2 = this.examTimeDbAdapter.getExamPointWay(kdid, drvpreasign.getKscx());
        if ("0".equals(sysset2046)) {
            String[] way = esExampointway2.getExamway().split(",");
            Random rand2 = new Random();
            String sjxl2 = way[rand2.nextInt(way.length)];
            if (!drvpreasign.getKsxl().contains(",")) {
                if ("".equals(drvpreasign.getKsxl()) || drvpreasign.getKsxl() == null) {
                    ksxl = sjxl2;
                }
                else {
                    ksxl = drvpreasign.getKsxl() + "," + sjxl2;
                }
            }
            else {
                ksxl = drvpreasign.getKsxl().substring(drvpreasign.getKsxl().indexOf(",") + 1);
            }
        }
        else {
            String[] way = esExampointway2.getExamway().split(",");
            String[] way2 = sysset2046.split(",");
            int sum = 0;
            for (int k = 0; k < way2.length; ++k) {
                sum += Integer.parseInt(way2[k]);
            }
            if (sum == 10) {
                ArrayList<String> list2 = new ArrayList();
                for (int i = 0; i < way.length; ++i) {
                    for (int j = 0; j < Integer.parseInt(way2[i]); ++j) {
                        list2.add(way[i]);
                    }
                }
                way = (String[])list2.toArray(new String[list2.size()]);
                Random rand = new Random();
                String sjxl = ksxl = way[rand.nextInt(way.length)];
            }
            else {
                throw new RspException("1", "概率分配不正确1");
            }
        }
        return ksxl;
    }
    
    public void deleteStuInfoSfz(String sfzmhm, EsCarinfo esCarInfo, EsDrvpreasign drvpreasign) throws Exception {
        String cardNoTemp = esCarInfo.getCardNoArray();
        if (cardNoTemp.indexOf(sfzmhm) != -1) {
            cardNoTemp = cardNoTemp.replace(sfzmhm, "");
            if (cardNoTemp.contains(",")) {
                cardNoTemp = cardNoTemp.replaceAll(",+", ",");
                cardNoTemp = cardNoTemp.replaceAll(",$", "");
                cardNoTemp = cardNoTemp.replaceAll("^,", "");
            }
            esCarInfo.setCardNoArray(cardNoTemp);
            this.carExamInfoDbAdapter.updateCarInfo(esCarInfo);
            if (drvpreasign == null) {
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "无效考生:" + sfzmhm);
            }
            else if ("17".equals(ConfigParam.SITE_VERSION) && 6 == (byte)drvpreasign.getKszt()) {
                drvpreasign.setCarCode(null);
                this.examineeInfoDbAdapter.updateExamineeInfo(drvpreasign);
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "考生:" + drvpreasign.getXm() + "/" + sfzmhm + "阶段考试完成");
            }
            else {
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "考生:" + drvpreasign.getXm() + "/" + sfzmhm + "考试完成");
            }
        }
    }
    
    public void firstAssignCarIsComplete(EsCarinfo esCarInfo, String sysset2303, String sysset2405) throws Exception {
        if ("32".equals(ConfigParam.SITE_VERSION) && !"".equals(sysset2405) && sysset2405 != null && !"0".equals(sysset2405)) {
            String today = CommonFileld.formatterYmd.format(new Date());
            String kskm = esCarInfo.getEsExampointdetail().getType();
            String kchp = esCarInfo.getCarcode();
            Long kdid = esCarInfo.getEsExampointdetail().getId();
            if (StringUtils.isBlank(sysset2303)) {
                sysset2303 = "2000-12-12";
            }
            String kskssj = CommonFileld.formatterYmd.format(CommonFileld.formatterYmd.parse(sysset2303));
            if (!kskssj.equals(today)) {
                String sysset2406 = null;
                String sysset2407;
                try {
                    sysset2407 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 190);
                    sysset2406 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 191);
                }
                catch (Exception e) {
                    throw new RspException("1", e);
                }
                StringBuilder sql1 = new StringBuilder();
                sql1.append("select count(1) from ES_DRVPREASIGN t where (t.car_code is null or t.car_code ='").append(kchp).append("')");
                sql1.append(" and t.kskm ='").append(kskm).append("'");
                sql1.append(" and t.kszt in (2,3,4) and t.kssycs > 0 and t.ykrq = trunc(sysdate) order by kszt desc");
                int numWait = this.examineeInfoDbAdapter.getMyIntegerValue(sql1);
                StringBuilder sql2 = new StringBuilder();
                sql2.append("select count(1) from ES_Carinfo t where t.device_status='1' and t.exampointid =").append(kdid);
                int count = this.examineeInfoDbAdapter.getMyIntegerValue(sql2);
                int realReqNum = (int)Integer.valueOf(sysset2407) + (int)Integer.valueOf(sysset2406);
                int numShangCheSys190 = (int)Integer.valueOf(sysset2407) * count;
                if (numWait < numShangCheSys190) {
                    throw new RspException("1", "待分配人数" + numWait + ",小于阈值" + numShangCheSys190);
                }
                List<EsCarinfo> carInfos = this.carExamInfoDbAdapter.getAllCarInfo((long)kdid);
                if (carInfos.size() < (int)Integer.valueOf(sysset2405)) {
                    throw new RspException("1", "待考车辆" + carInfos.size() + ",小于设定在" + sysset2405);
                }
                for (EsCarinfo esCarinfo : carInfos) {
                    Long kscc = this.getJgAssignKscc(esCarinfo, kskm, sysset2405);
                    try {
                        this.thirdPartHandleService.sendForWriteObjectOut_17CB3_HN(realReqNum, kscc, esCarinfo, "");
                    }
                    catch (Exception ex) {}
                }
                this.commonMethodDbAdapter.executeSQL("update ma_sysset set v_value='" + today + "' where v_no=2303 and kdid='" + kdid + "'", new Object[0]);
            }
        }
    }
    
    public String getGateZwh(Long kdid, EsDrvpreasign examineeInfo) throws Exception {
        if (!StringUtils.isEmpty(examineeInfo.getSjxmdm())) {
            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "项目已随机，直接返回.sjxmdm=" + examineeInfo.getSjxmdm());
            return null;
        }
        String siteVersion = ConfigParam.SITE_VERSION;
        String ksdd = examineeInfo.getKsdd();
        String ksxmsmTemp = null;
        if ("21".equals(siteVersion) || "49".equals(siteVersion) || "55".equals(siteVersion)) {
            String ksxmName = null;
            if ("21".equals(siteVersion) || "55".equals(siteVersion)) {
                ksxmName = "倒车入库";
            }
            else if ("49".equals(siteVersion)) {
                ksxmName = "坡道";
            }
            StringBuilder sql = new StringBuilder();
            sql.append("select count(s.lsh) cn ,t.itemsno,t.ksxmsm from ");
            sql.append(" (select * from ma_cdsbinfo a where a.ksxmsm like '%").append(ksxmName).append("%'").append(" and a.kdid =").append(kdid);
            if ("49".equals(siteVersion)) {
                sql.append(" and  a.bk1 ='").append(examineeInfo.getKscc()).append("'");
            }
            sql.append(") t left join ");
            sql.append(" (select * from es_drvpreasign b where b.ksdd = '").append(ksdd).append("' and b.ykrq = trunc(sysdate)) s");
            sql.append(" on t.itemsno = s.sjxmdm group by t.itemsno,t.ksxmsm order by cn");
            List<MaCdsbinfo> maCdsbinfos = this.initializationDbAdapter.getMaCdsbinfoByKdIdAndKsxmsmNew(sql);
            List<MaCdsbinfo> ranMaCdsbinfos = new ArrayList();
            ranMaCdsbinfos.add((MaCdsbinfo)maCdsbinfos.get(0));
            for (int i = 0; i < maCdsbinfos.size() && ((MaCdsbinfo)maCdsbinfos.get(0)).readCount() == ((MaCdsbinfo)maCdsbinfos.get(i)).readCount(); ++i) {
                ranMaCdsbinfos.add((MaCdsbinfo)maCdsbinfos.get(i));
            }
            int indexTemp = new Random().nextInt(ranMaCdsbinfos.size());
            examineeInfo.setBk4(((MaCdsbinfo)ranMaCdsbinfos.get(indexTemp)).getKsxmsm());
            ksxmsmTemp = ((MaCdsbinfo)ranMaCdsbinfos.get(indexTemp)).getItemsno();
        }
        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "本次随机项目:" + ksxmsmTemp);
        return ksxmsmTemp;
    }
    
    public String getZjClppToArea(String clpp) {
        String fieldId = null;
        String fieldIdArea = ConfigParam.ClppToArea;
        Map<String, String> fieldIdMap = new HashMap();
        if (StringUtils.isNotEmpty(fieldIdArea)) {
            String[] fieldIdAreaArray = fieldIdArea.split(";");
            for (int i = 0; i < fieldIdAreaArray.length; ++i) {
                String[] fieldIds = fieldIdAreaArray[i].split(",");
                fieldIdMap.put(fieldIds[0], fieldIds[1]);
            }
        }
        fieldId = (String)fieldIdMap.get(clpp);
        return fieldId;
    }
    
    public String getFsKsccByFieldid(String clpp, String tempStr) {
        String fieldId = null;
        String fieldIdArea = tempStr;
        Map<String, String> fieldIdMap = new HashMap();
        if (StringUtils.isNotEmpty(fieldIdArea)) {
            String[] fieldIdAreaArray = fieldIdArea.split(";");
            for (int i = 0; i < fieldIdAreaArray.length; ++i) {
                String[] fieldIds = fieldIdAreaArray[i].split("~");
                fieldIdMap.put(fieldIds[0], fieldIds[1]);
            }
        }
        fieldId = (String)fieldIdMap.get(clpp);
        return fieldId;
    }
    
    public void autoAssignJgfcTask(Long kdid, String ksdd, String kskm, int realReqNum, String sysset2109, String cartype) throws Exception {
        if (ConfigParam.SITE_VERSION.contains("YICHANG")) {
            String sqlStr = "select count(*) from es_drvpreasign where sfqk='0' and ksdd='" + ksdd + "' and kscx='" + cartype + "' and car_code is null and kszt=0 and ykrq=trunc(sysdate)";
            int numDD = this.examineeInfoDbAdapter.getMyIntegerValue2(sqlStr);
            if (numDD > 0) {
                throw new RspException("1", "请" + cartype + "考生继续监管签到,数据库还有" + numDD + "个未签到");
            }
        }
        if (ConfigParam.SITE_VERSION.contains("ShenYang")) {
            StringBuilder hql = new StringBuilder();
            hql.append(" from ").append(EsDrvpreasign.class.getName());
            hql.append(" t where t.sfqk ='0' ");
            hql.append(" and t.ksdd='").append(ksdd).append("'");
            hql.append(" and t.kskm='").append(kskm).append("'");
            hql.append(" and t.kscx='").append(cartype).append("'");
            hql.append(" and car_code is null and t.kssycs >0 and t.kszt in(1,2) and t.ykrq = trunc(sysdate) order by t.xh asc");
            List<EsDrvpreasign> esDrvpreasignlist = this.examineeInfoDbAdapter.getDrvpreasignInfoListByHQL(hql);
            if (esDrvpreasignlist.size() < 3) {
                String sqlStr2 = "select count(*) from es_drvpreasign where sfqk='0' and ksdd='" + ksdd + "' and kscx='" + cartype + "' and car_code is null and kszt=0 and ykrq=trunc(sysdate)";
                int numDD2 = this.examineeInfoDbAdapter.getMyIntegerValue2(sqlStr2);
                if (numDD2 > 0) {
                    throw new RspException("1", "请" + cartype + "考生继续监管签到,数据库还有" + numDD2 + "个未签到");
                }
            }
        }
        StringBuilder hql = new StringBuilder();
        hql.append(" from ").append(EsDrvpreasign.class.getName());
        hql.append(" t where t.sfqk ='0' ");
        hql.append(" and t.ksdd='").append(ksdd).append("'");
        hql.append(" and t.kskm='").append(kskm).append("'");
        hql.append(" and t.kscx='").append(cartype).append("'");
        hql.append(" and car_code is null and t.kssycs >0 and t.kszt in(1,2) and t.ykrq = trunc(sysdate) order by t.xh asc");
        List<EsDrvpreasign> esDrvpreasignlist = this.examineeInfoDbAdapter.getDrvpreasignInfoListByHQL(hql);
        if (esDrvpreasignlist.size() < 1) {
            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + cartype + "退出分车/本地数据库已无待分配考生/ksdd=" + ksdd + "/kszt=(1,2)/kdid=" + kdid);
        }
        else {
            this.clearKongXianCar(kdid);
            this.randomCarInfoOrder(kdid.toString());
            List<EsCarinfo> esCarinfos = this.carExamInfoDbAdapter.getAllCarInfo_2((long)kdid, realReqNum, cartype);
            if (esCarinfos == null || esCarinfos.isEmpty()) {
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + cartype + "退出分车/所有考车都已分配考生/ksdd=" + ksdd + "/kdid=" + kdid);
            }
            else {
                String sysset2110 = this.initializationDbAdapter.queryMaSyssetByCache(kdid, 2045);
                for (int i = 1; i <= esCarinfos.size(); ++i) {
                    EsCarinfo esCarInfo = (EsCarinfo)esCarinfos.get(i - 1);
                    if ("0".equals(sysset2109) || (int)esCarInfo.getNumFcrs() <= 0) {
                        String kscx = esCarInfo.getCartype();
                        String carName = esCarInfo.getCarcode() + "(" + esCarInfo.getCarno() + ")";
                        List<EsDrvpreasign> esDrvpreasignsTemp = this.examineeInfoDbAdapter.getDrvpreasignInfoListByHQL(hql);
                        if (esDrvpreasignsTemp.size() < 1) {
                            String sqlStr3 = "select count(*) from es_drvpreasign where sfqk='0' and ksdd='" + ksdd + "' and kscx='" + kscx + "' and kszt=0 and car_code is null and ykrq=trunc(sysdate)";
                            int numDD3 = this.examineeInfoDbAdapter.getMyIntegerValue2(sqlStr3);
                            if (numDD3 > 0) {
                                sqlStr3 = kscx + "退出分车/请" + kscx + "考生继续监管签到,数据库还有" + numDD3 + "个未签到";
                                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + sqlStr3);
                                break;
                            }
                            sqlStr3 = kscx + "退出分车/已无待分配考生/kskm=" + kskm + "/ksdd=" + ksdd;
                            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + sqlStr3);
                            break;
                        }
                        else {
                            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "/自动分车:(" + i + "/" + esCarinfos.size() + ")/kscx=" + kscx + "/sfzList=" + esCarInfo.getCardNoArray());
                            Long kscc = this.getJgAssignKscc(esCarInfo, kskm, sysset2110);
                            String isSucc = this.thirdPartHandleService.sendForWriteObjectOut_17CB3_ZhengZhou(realReqNum, kscc, esCarInfo);
                            if ("1".equals(isSucc)) {
                                boolean flag = this.writeKchpToDrvpreasign(esCarInfo, realReqNum);
                                if (!flag && !"1".equals(sysset2110)) {
                                    CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "退出分车/没有给足人数，说明该车型监管上已无待分配考生");
                                    break;
                                }
                            }
                            else if ("2".equals(isSucc)) {
                                if (!"1".equals(sysset2110)) {
                                    CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "退出分车/kscc=" + kscc + "/监管平台已无该场次待分配考生");
                                    break;
                                }
                            }
                            else {
                                "3".equals(isSucc);
                            }
                        }
                    }
                }
            }
        }
    }
    
    public boolean writeKchpToDrvpreasign(EsCarinfo esCarInfo, int realReqNum) throws Exception {
        String dateTime = CommonFileld.formatterYmdNoConnect.format(new Date());
        String kskm = esCarInfo.getEsExampointdetail().getType();
        String ksdd = esCarInfo.getEsExampointdetail().getCode();
        String kchp = esCarInfo.getCarcode();
        String carid = esCarInfo.getCarcode() + "(" + esCarInfo.getCarno() + ")";
        String sfzmhmListLs = esCarInfo.getCardNoArray();
        String[] sfzmhmArr = null;
        List<String> cardNos = new ArrayList();
        if (sfzmhmListLs != null && !"".equals(sfzmhmListLs)) {
            sfzmhmArr = sfzmhmListLs.split(",");
            for (int i = 0; i < sfzmhmArr.length; ++i) {
                cardNos.add(sfzmhmArr[i]);
            }
        }
        for (int i = 0; i < cardNos.size(); ++i) {
            EsDrvpreasign drvpreasign = null;
            try {
                drvpreasign = this.examineeInfoDbAdapter.getAllExamineeInfoByCardNo((String)cardNos.get(i), dateTime, ksdd, kskm, "", "");
            }
            catch (Exception e) {
                throw new RspException("1", "查询考生出错");
            }
            if (drvpreasign == null) {
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "数据库无此考生:" + (String)cardNos.get(i));
            }
            else {
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carid + "郑州模式/监管分车前:xm=" + drvpreasign.getXm() + "/sfzmhm=" + drvpreasign.getSfzmhm() + "/ksxl=" + drvpreasign.getKsxl() + "/kszt=" + drvpreasign.getKszt() + "/flag=" + drvpreasign.getFlag() + "/carcode=" + drvpreasign.getCarCode() + ",kssycs=" + drvpreasign.getKssycs() + ",sfqk=" + drvpreasign.getSfqk());
                this.examineeInfoDbAdapter.evict(drvpreasign);
                if (!kchp.equals(drvpreasign.getCarCode())) {
                    drvpreasign.setCarCode(kchp);
                    long countXh = (long)this.examineeInfoDbAdapter.findMaxXh(dateTime, ksdd, "1000");
                    drvpreasign.setXh(Integer.valueOf(new Long(countXh).intValue() + 1));
                    this.examineeInfoDbAdapter.updateExamineeInfo(drvpreasign);
                }
            }
        }
        return realReqNum <= cardNos.size();
    }
    
    public void clearKongXianCar(Long kdid) {
        List<EsCarinfo> esCarinfos;
        try {
            esCarinfos = this.carExamInfoDbAdapter.getAllCarInfoCardNotNull((long)kdid);
        }
        catch (Exception e) {
            throw new RspException("1", e);
        }
        if (esCarinfos == null || esCarinfos.isEmpty()) {
            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "kdid=" + kdid + "所有考车都没有分配考生");
        }
        else {
            for (int i = 0; i < esCarinfos.size(); ++i) {
                EsCarinfo esCarInfo = (EsCarinfo)esCarinfos.get(i);
                String carName = esCarInfo.getCarcode() + "(" + esCarInfo.getCarno() + ")";
                String cardNoTemp = esCarInfo.getCardNoArray();
                if (cardNoTemp != null) {
                    SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMdd");
                    List<EsDrvpreasign> esDrvpreasignsTemp = null;
                    StringBuilder HQL = new StringBuilder();
                    HQL.append(" from ").append(EsDrvpreasign.class.getName());
                    HQL.append(" t where ((t.sfqk = '1') or ((t.kszt=5 or t.kssycs <=0) and t.carCode='").append(esCarInfo.getCarcode()).append("') )");
                    HQL.append(" and t.ykrq = to_date('" + formatter.format(new Date()) + "','yyyy-MM-dd') order by t.xh");
                    esDrvpreasignsTemp = this.examineeInfoDbAdapter.getDrvpreasignInfoListByHQL(HQL);
                    if (esDrvpreasignsTemp != null && !esDrvpreasignsTemp.isEmpty()) {
                        for (int indexJg = 0; indexJg < esDrvpreasignsTemp.size(); ++indexJg) {
                            EsDrvpreasign esDrvpreasignDownLoad = (EsDrvpreasign)esDrvpreasignsTemp.get(indexJg);
                            if (cardNoTemp.indexOf(esDrvpreasignDownLoad.getSfzmhm()) != -1) {
                                cardNoTemp = cardNoTemp.replace(esDrvpreasignDownLoad.getSfzmhm(), "");
                                if (cardNoTemp.contains(",")) {
                                    cardNoTemp = cardNoTemp.replaceAll(",+", ",");
                                    cardNoTemp = cardNoTemp.replaceAll(",$", "");
                                    cardNoTemp = cardNoTemp.replaceAll("^,", "");
                                }
                                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "剔除考生:" + esDrvpreasignDownLoad.getXm() + "/" + esDrvpreasignDownLoad.getSfzmhm());
                            }
                        }
                        esCarInfo.setCardNoArray(cardNoTemp);
                    }
                }
                int numKssl = 0;
                String sfzmhmListLs = cardNoTemp;
                if (sfzmhmListLs == null || "".equals(sfzmhmListLs)) {
                    numKssl = 0;
                }
                else if (sfzmhmListLs.length() < 18) {
                    numKssl = 0;
                }
                else if (sfzmhmListLs.length() <= 40) {
                    numKssl = 2;
                }
                else if (sfzmhmListLs.length() <= 60) {
                    numKssl = 3;
                }
                else if (sfzmhmListLs.length() <= 80) {
                    numKssl = 4;
                }
                else if (sfzmhmListLs.length() <= 100) {
                    numKssl = 5;
                }
                else if (sfzmhmListLs.length() <= 120) {
                    numKssl = 6;
                }
                esCarInfo.setNumFcrs(Integer.valueOf(numKssl));
                if (esCarInfo.getAssignTime() != null) {
                    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
                    String sToday = sdf.format(new Date());
                    String sYestoday = sdf.format(esCarInfo.getAssignTime());
                    if (sYestoday.compareTo(sToday) < 0) {
                        esCarInfo.setAssignTime(null);
                        esCarInfo.setCardNoArray(null);
                    }
                }
                this.carExamInfoDbAdapter.updateCarInfo(esCarInfo);
            }
        }
    }
    
    public void randomCarInfoOrder(String kdid) {
        StringBuilder hql = new StringBuilder();
        hql.append("from ").append(EsCarinfo.class.getName());
        hql.append(" t where t.deviceStatus = '1' and t.esExampointdetail.id=").append(kdid);
        List<EsCarinfo> esCarinfos = null;
        try {
            esCarinfos = this.carExamInfoDbAdapter.getAllCarInfo2(hql.toString());
        }
        catch (Exception e) {
            throw new RspException("1", e);
        }
        if (esCarinfos != null && esCarinfos.size() >= 1) {
            for (int i = 0; i < 1; ++i) {
                hql.setLength(0);
                hql.append("from ").append(EsCarinfo.class.getName());
                hql.append(" t where t.deviceStatus = '1' and t.esExampointdetail.id=").append(kdid).append(" order by t.createdBy,t.carno");
                try {
                    esCarinfos = this.carExamInfoDbAdapter.getAllCarInfo2(hql.toString());
                }
                catch (Exception e2) {
                    throw new RspException("1", e2);
                }
                for (int index = 0; index < esCarinfos.size(); ++index) {
                    EsCarinfo esCarinfoTemp = (EsCarinfo)esCarinfos.get(index);
                    int num = (int)(Math.random() * 1000.0);
                    if (num < 1000) {
                        num += 1000;
                    }
                    esCarinfoTemp.setCreatedBy(Long.valueOf(Long.parseLong(new StringBuilder(String.valueOf(num)).toString())));
                    esCarinfoTemp.setCreatedDate(new Date());
                    this.carExamInfoDbAdapter.updateCarInfo(esCarinfoTemp);
                }
            }
        }
    }
    
    public void autoAssignFcslIsRight(EsCarinfo esCarInfo) throws Exception {
        Long kdid = esCarInfo.getEsExampointdetail().getId();
        String ksdd = esCarInfo.getEsExampointdetail().getCode();
        String kscx = esCarInfo.getCartype();
        String carName = esCarInfo.getCarcode() + "(" + esCarInfo.getCarno() + ")";
        String sysset2115 = "0";
        if ("0".equals(sysset2115)) {
            if ("JILIN".equals(ConfigParam.SITE_VERSION)) {
                this.clearKongXianCar(kdid);
            }
            try {
                String sysset2116 = "0,0,0,0,0,0,0";
                String[] numList = sysset2116.split(",");
                int num = 1;
                if ("C1".equals(kscx)) {
                    num = (int)Integer.valueOf(numList[0]);
                }
                else if ("C2".equals(kscx)) {
                    num = (int)Integer.valueOf(numList[1]);
                }
                else if ("B2".equals(kscx)) {
                    num = (int)Integer.valueOf(numList[3]);
                }
                String sqlStr = "select distinct(carcode) from es_carinfo where (numFcrs >0 or card_no_array is not null) and exampointcode='" + ksdd + "' and cartype='" + kscx + "'";
                List<Object[]> objList = this.examineeInfoDbAdapter.getMyobjectListBySql(sqlStr);
                if (objList.size() < num) {
                    sqlStr = "select distinct(car_code) from es_drvpreasign where (car_code is not null) and ksdd='" + ksdd;
                    sqlStr = sqlStr + "' and kscx='" + kscx + "' and kssycs>0 and kszt<5 and ykrq=trunc(sysdate)";
                    objList = this.examineeInfoDbAdapter.getMyobjectListBySql(sqlStr);
                    if (objList.size() < num) {
                        sqlStr = "select count(*) from es_drvpreasign where sfqk='0' and kszt=0 and car_code is null and ksdd='" + ksdd + "' and kscx='" + kscx + "' and ykrq=trunc(sysdate)";
                        int numDk = this.examineeInfoDbAdapter.getMyIntegerValue2(sqlStr);
                        if (numDk > 0) {
                            sqlStr = kscx + "分车数量未达标,系统预设值" + num + "/实际分车" + objList.size() + "/数据库还有" + numDk + "个待考,请继续签到或开启更多的考车";
                            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + sqlStr);
                            throw new RspException("1", kscx + "分车数量未达标,数据库还有" + numDk + "个待考,请继续签到或开启更多的考车");
                        }
                        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + kscx + "分车数量达标3,系统预设值" + num + "/实际分车" + objList.size());
                    }
                    else {
                        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + kscx + "分车数量达标2,系统预设值" + num + "/实际分车" + objList.size());
                    }
                }
                else {
                    CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + kscx + "分车数量达标1,系统预设值" + num + "/实际分车" + objList.size());
                }
            }
            catch (Exception e) {
                throw new RspException("1", e);
            }
        }
    }
    
    public void der2VersionIsRight(long kdid) throws Exception {
        try {
            String sysset2601 = null;
            sysset2601 = this.initializationDbAdapter.queryMaSyssetByCache(Long.valueOf(kdid), 2601);
            if (sysset2601.length() < 10) {
                sysset2601 = "2000-01-01";
            }
            if (!"2024-09-30".equals(sysset2601)) {
                String sysset2602 = this.initializationDbAdapter.queryMaSyssetByCache(Long.valueOf(kdid), 2600);
                if ("2024-09-30".compareTo(sysset2601) > 0) {
                    this.commonMethodDbAdapter.executeSQL("update ma_sysset set v_value='2024-09-30' where v_no=2601 and kdid=" + kdid, new Object[0]);
                }
                else if ("0".equals(sysset2602)) {
                    throw new RspException("1", "中心版本已升级,老程序不能继续使用!!!");
                }
            }
        }
        catch (Exception e) {
            throw new RspException("1", e);
        }
    }
    
    public String getAqyCode(EsDrvpreasign esDrvpreasign, EsCarinfo esCarInfo) throws Exception {
        String ksdd = esDrvpreasign.getKsdd();
        String carName = esCarInfo.getCarcode() + "(" + esCarInfo.getCarno() + ")";
        String aqyCode = null;
        String aqyName = null;
        boolean newSignAqy = false;
        if (esCarInfo.getMaExaminerInfoByExaminerId1() == null) {
            newSignAqy = true;
        }
        else {
            MaExaminerInfo examinerInfo = esCarInfo.getMaExaminerInfoByExaminerId1();
            aqyName = "安全员:" + examinerInfo.getName() + "/Code=" + examinerInfo.getCode() + "/sfz=" + examinerInfo.getCardNo();
            String sToday = CommonFileld.formatterYmd.format(new Date());
            String quitTime = CommonFileld.formatterYmd.format(examinerInfo.getQuitTime());
            String signTime = CommonFileld.formatterYmd.format(examinerInfo.getSignTime());
            if (signTime.equals(sToday)) {
                if (quitTime.equals(sToday)) {
                    newSignAqy = true;
                }
                else {
                    aqyCode = examinerInfo.getCode();
                    String sql = "select count(*) from es_drvpreasign where ksdd='" + ksdd + "' and ksy1sfzmhm='" + aqyCode + "' and ykrq=trunc(sysdate)";
                    int num = this.examineeInfoDbAdapter.getMyIntegerValue2(sql);
                    int num2 = 3;
                    if (ConfigParam.JKID3_2 != null && !"".equals(ConfigParam.JKID3_2)) {
                        num2 = Integer.parseInt(ConfigParam.JKID3_2);
                    }
                    if (num >= num2) {
                        examinerInfo.setQuitTime(new Date());
                        this.examinerInfoDbAdapter.updateExaminerInfo(examinerInfo);
                        newSignAqy = true;
                        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + aqyName + "监考人数已满，系统自动剔除," + carName);
                    }
                }
            }
            else {
                newSignAqy = true;
            }
        }
        if (newSignAqy) {
            Long kdid = esCarInfo.getEsExampointdetail().getId();
            MaExaminerInfo examinerInfoTemp = this.examinerInfoDbAdapter.getExaminerInfoById((long)kdid);
            if (examinerInfoTemp != null) {
                aqyCode = examinerInfoTemp.getCode();
                esCarInfo.setMaExaminerInfoByExaminerId1(examinerInfoTemp);
                this.carExamInfoDbAdapter.updateCarInfo(esCarInfo);
                aqyName = "安全员:" + examinerInfoTemp.getName() + "/Code=" + examinerInfoTemp.getCode() + "/sfz=" + examinerInfoTemp.getCardNo();
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + aqyName + "分配考车成功," + carName);
            }
        }
        String stuName = "考生:" + esDrvpreasign.getXm() + "/" + esDrvpreasign.getSfzmhm();
        String reason = stuName + ",监考" + aqyName;
        this.webOperateLogDbAdapter.saveSuccessLog(reason, "中心分车");
        return aqyCode;
    }
    
    public void HeBeiAssignCar(EsCarinfo esCarInfo) {
        String kskm = esCarInfo.getEsExampointdetail().getType();
        String ksdd = esCarInfo.getEsExampointdetail().getCode();
        String kchp = esCarInfo.getCarcode();
        String carName = kchp + "(" + esCarInfo.getCarno() + ")";
        String code = null;
        String message = null;
        String rownum = null;
        String rspXML = null;
        String reqXml = null;
        Document document = null;
        reqXml = "<?xml version=\"1.0\" encoding=\"utf-8\"?><root><exm><ksdd>" + ksdd + "</ksdd><kskm>" + kskm + "</kskm><kchp>" + UrlCodeTool.encodeUTF8(kchp) + "</kchp><ybks>0</ybks></exm></root>";
        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "读取考车流水信息请求-reqXml:" + reqXml);
        JaxWsDynamicClientFactory dcf = JaxWsDynamicClientFactory.newInstance();
        Client client = dcf.createClient(ConfigParam.URL3_1);
        Object[] objects = null;
        try {
            objects = client.invoke("queryObjectOut", new Object[] { "92", ConfigParam.JKXLH3_1, "92D02", reqXml });
            rspXML = (String)objects[0];
            rspXML = URLDecoder.decode(rspXML, "UTF-8");
            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "考车流水信息返回-rspXML:" + rspXML);
            document = DocumentHelper.parseText(rspXML);
        }
        catch (Exception e) {
            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "调用考车流水信息发生错误:" + e);
        }
        Element root = document.getRootElement();
        Element headElm = root.element("head");
        Element codeElm = headElm.element("code");
        Element messageElm = headElm.element("message");
        Element rownumElm = headElm.element("rownum");
        code = ((codeElm == null) ? null : codeElm.getText());
        message = ((messageElm == null) ? null : UrlCodeTool.decodeUTF8(messageElm.getText()));
        rownum = ((rownumElm == null) ? null : rownumElm.getText());
        if ("1".equals(code)) {
            if (!"0".equals(rownum)) {
                String xm = "";
                String lsh = "";
                String sfzmhm = "";
                String zkzmbh = "";
                String kscx = "";
                String ksy1 = "";
                String carCode = "";
                String bmzp = "";
                String ykxm = "";
                String kfxm = "";
                String kskssj = "";
                Element exmElm = root.element("Exm");
                Element ele = exmElm.element("XM");
                if (ele != null) {
                    xm = UrlCodeTool.decodeUTF8(ele.getTextTrim());
                }
                ele = exmElm.element("LSH");
                if (ele != null) {
                    lsh = UrlCodeTool.decodeUTF8(ele.getTextTrim());
                }
                ele = exmElm.element("SFZMHM");
                if (ele != null) {
                    sfzmhm = UrlCodeTool.decodeUTF8(ele.getTextTrim());
                }
                ele = exmElm.element("KCHP");
                if (ele != null) {
                    carCode = UrlCodeTool.decodeUTF8(ele.getTextTrim());
                }
                ele = exmElm.element("ZKZMBH");
                if (ele != null) {
                    zkzmbh = UrlCodeTool.decodeUTF8(ele.getTextTrim());
                }
                ele = exmElm.element("KSCX");
                if (ele != null) {
                    kscx = UrlCodeTool.decodeUTF8(ele.getTextTrim());
                }
                ele = exmElm.element("KSY1");
                if (ele != null) {
                    ksy1 = UrlCodeTool.decodeUTF8(ele.getTextTrim());
                }
                ele = exmElm.element("YKXM");
                if (ele != null) {
                    ykxm = UrlCodeTool.decodeUTF8(ele.getTextTrim());
                }
                ele = exmElm.element("KFXM");
                if (ele != null) {
                    kfxm = UrlCodeTool.decodeUTF8(ele.getTextTrim());
                }
                ele = exmElm.element("KSKSSJ");
                if (ele != null) {
                    kskssj = UrlCodeTool.decodeUTF8(ele.getTextTrim());
                }
                try {
                    StringBuilder sql = new StringBuilder();
                    sql.append("update es_drvpreasign set kszt=5 where car_code='").append(carCode).append("' and kszt<5 and ykrq=trunc(sysdate)");
                    this.examineeInfoDbAdapter.updateOrDelte(sql.toString());
                }
                catch (Exception e2) {
                    CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "update es_drvpreasign发生错误");
                }
                String ksrq = CommonFileld.formatterYmd.format(new Date());
                EsDrvpreasign ksxxInfo = null;
                try {
                    ksxxInfo = this.examineeInfoDbAdapter.getDrvpreasignInfoBySfzKskm(sfzmhm, kskm, ksrq);
                }
                catch (Exception e3) {
                    throw new RspException("1", e3);
                }
                try {
                    if (ksxxInfo == null) {
                        ele = exmElm.element("ZP");
                        if (ele != null) {
                            bmzp = ele.getTextTrim();
                        }
                        EsDrvpreasign examineeInfo = new EsDrvpreasign();
                        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");
                        examineeInfo.setXm(xm);
                        examineeInfo.setLsh(lsh);
                        examineeInfo.setZkzmbh(zkzmbh);
                        examineeInfo.setSfzmhm(sfzmhm);
                        examineeInfo.setCarCode(carCode);
                        examineeInfo.setKscx(kscx);
                        examineeInfo.setKskm(kskm);
                        examineeInfo.setKsdd(ksdd);
                        examineeInfo.setSfqk("0");
                        examineeInfo.setFlag("0");
                        examineeInfo.setKscs(Short.valueOf("1"));
                        examineeInfo.setKsxl("1");
                        examineeInfo.setKscc(Long.valueOf(1L));
                        examineeInfo.setKszt(Byte.valueOf("0"));
                        examineeInfo.setBcyykscs(Byte.valueOf("2"));
                        examineeInfo.setKssycs(Byte.valueOf("2"));
                        examineeInfo.setKsy1(ksy1);
                        examineeInfo.setKsy2(ksy1);
                        examineeInfo.setKsrq(df.parse(ksrq));
                        examineeInfo.setYkrq(df.parse(ksrq));
                        examineeInfo.setYyrq(df.parse(ksrq));
                        examineeInfo.setCreatedBy(Long.valueOf(1L));
                        examineeInfo.setCreatedDate(new Date());
                        if (ykxm != null && "".equals(ykxm)) {
                            examineeInfo.setBk1(ykxm);
                        }
                        else {
                            examineeInfo.setBk1("");
                        }
                        if (kfxm != null && "".equals(kfxm)) {
                            examineeInfo.setBk2(kfxm);
                        }
                        else {
                            examineeInfo.setBk2("");
                        }
                        if (kskssj != null && "".equals(kskssj)) {
                            examineeInfo.setBk3(kskssj);
                        }
                        else {
                            examineeInfo.setBk3("");
                        }
                        this.examineeInfoDbAdapter.saveExamineeInfo(examineeInfo);
                        this.compositeCallDbAdapter.setBmzpPhoto(bmzp, examineeInfo);
                        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + xm + "/" + sfzmhm + "/初次读取kchp=" + carCode);
                    }
                    else {
                        ksxxInfo.setXm(xm);
                        ksxxInfo.setLsh(lsh);
                        ksxxInfo.setSfzmhm(sfzmhm);
                        ksxxInfo.setCarCode(carCode);
                        if ((byte)ksxxInfo.getKssycs() < 1) {
                            ksxxInfo.setKssycs(Byte.valueOf("1"));
                        }
                        ksxxInfo.setKszt(Byte.valueOf("4"));
                        ksxxInfo.setFlag("0");
                        ksxxInfo.setKscx(kscx);
                        ksxxInfo.setKskm(kskm);
                        ksxxInfo.setKsdd(ksdd);
                        if (ykxm != null && "".equals(ykxm)) {
                            ksxxInfo.setBk1(ykxm);
                        }
                        else {
                            ksxxInfo.setBk1("");
                        }
                        if (kfxm != null && "".equals(kfxm)) {
                            ksxxInfo.setBk2(kfxm);
                        }
                        else {
                            ksxxInfo.setBk2("");
                        }
                        if (kskssj != null && "".equals(kskssj)) {
                            ksxxInfo.setBk3(kskssj);
                        }
                        else {
                            ksxxInfo.setBk3("");
                        }
                        this.examineeInfoDbAdapter.saveExamineeInfo(ksxxInfo);
                        CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + xm + "/" + sfzmhm + "/重复读取kchp=" + carCode);
                    }
                }
                catch (Exception e3) {
                    CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "考生信息写入本地库错误:", e3);
                }
            }
            else {
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "/无流水信息,返回Msg=" + message);
            }
        }
        else {
            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + carName + "/读取流水信息失败,返回Msg=" + message);
        }
    }
    
    public MaExaminerInfo assignNewMaExaminerInfo(String sysset2396, EsCarinfo esCarInfo) throws Exception {
        String ksy1sfzmhm = null;
        StringBuilder hql1 = new StringBuilder();
        hql1.append(" from ").append(EsDrvpreasign.class.getName()).append(" t where t.carCode='").append(esCarInfo.getCarcode()).append("'");
        hql1.append(" and t.ykrq = trunc(sysdate) order by t.xh desc");
        List<EsDrvpreasign> esDrvpreasigns1 = this.examineeInfoDbAdapter.getDrvpreasignInfoListByHQL(hql1);
        if (esDrvpreasigns1.size() > 0) {
            ksy1sfzmhm = ((EsDrvpreasign)esDrvpreasigns1.get(0)).getKsy1sfzmhm();
        }
        MaExaminerInfo examinerInfo = null;
        long kdid = (long)esCarInfo.getEsExampointdetail().getId();
        List<MaExaminerInfo> examinerInfolst = this.examinerInfoDbAdapter.getExaminerInfoByKdid(kdid);
        for (int i = 0; i < examinerInfolst.size(); ++i) {
            examinerInfo = (MaExaminerInfo)examinerInfolst.get(i);
            StringBuilder sql = new StringBuilder();
            sql.append("select count(*) from es_drvpreasign t where t.ksy1sfzmhm='").append(examinerInfo.getCardNo()).append("' and t.ykrq=trunc(sysdate)");
            int numIsComplete = this.examineeInfoDbAdapter.getMyIntegerValue(sql);
            if ((int)Integer.valueOf(sysset2396) >= numIsComplete) {
                examinerInfo.setIsFlag("0");
                this.examinerInfoDbAdapter.updateExaminerInfo(examinerInfo);
                String aqyName = esCarInfo.getMaExaminerInfoByExaminerId1().getName() + "/" + esCarInfo.getMaExaminerInfoByExaminerId1().getCardNo();
                CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "安全员" + aqyName + "/监考人数已达上限" + sysset2396);
            }
        }
        List<MaExaminerInfo> examinerInfolst2 = this.examinerInfoDbAdapter.getExaminerInfoOfQz(kdid, ksy1sfzmhm);
        try {
            if (examinerInfolst2.size() > 0) {
                int rand = 0;
                Random random = new Random();
                for (int j = 0; j < 5; ++j) {
                    rand = random.nextInt(examinerInfolst2.size() - 1);
                }
                return (MaExaminerInfo)examinerInfolst2.get(rand);
            }
            return null;
        }
        catch (Exception e) {
            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "随机安全员出错：" + e.getMessage());
            return null;
        }
    }
    
    public int autoAssignQzAqy(String sysset2395, String sysset2396, EsCarinfo esCarInfo) throws Exception {
        int reqNum = 0;
        String cardNo = null;
        String reMark = null;
        String aqyName = null;
        String carType = null;
        String carCode = esCarInfo.getCarcode();
        long kdid = (long)esCarInfo.getEsExampointdetail().getId();
        if (esCarInfo.getMaExaminerInfoByExaminerId1() == null) {
            MaExaminerInfo examinerInfo = this.assignNewMaExaminerInfo(sysset2396, esCarInfo);
            if (examinerInfo == null) {
                throw new RspException("1", "无有效安全员可用，请安全员继续签到！");
            }
            esCarInfo.setMaExaminerInfoByExaminerId1(examinerInfo);
            this.carExamInfoDbAdapter.updateCarInfo(esCarInfo);
            examinerInfo.setIsFlag("2");
            this.examinerInfoDbAdapter.updateExaminerInfo(examinerInfo);
            cardNo = esCarInfo.getMaExaminerInfoByExaminerId1().getCardNo();
            aqyName = esCarInfo.getMaExaminerInfoByExaminerId1().getName() + "/" + cardNo;
            reMark = "分车";
            this.examinerLoginDbAdapter.saveExaminnerSign(Long.valueOf(kdid), cardNo, carCode, carType, reMark);
            CarDownloadStuInfoService.LOGGER.info(this.commonMethodDbAdapter.getReqRandomId(null) + "中心随机分配安全员/" + aqyName + "/CarCode=" + carCode);
            if (esCarInfo.getMaExaminerInfoByExaminerId().getId() != esCarInfo.getMaExaminerInfoByExaminerId1().getId()) {
                throw new RspException("1", "安全员错误，当前考车安全员是" + esCarInfo.getMaExaminerInfoByExaminerId1().getName());
            }
            StringBuilder hql1 = new StringBuilder();
            hql1.append(" from ").append(EsDrvpreasign.class.getName()).append(" t where t.ksy1sfzmhm='").append(cardNo).append("'");
            hql1.append(" and t.ykrq = trunc(sysdate) order by t.xh desc");
            List<EsDrvpreasign> esDrvpreasigns = this.examineeInfoDbAdapter.getDrvpreasignInfoListByHQL(hql1);
            int numIsAssign2 = esDrvpreasigns.size();
            int numMod2 = numIsAssign2 % (int)Integer.valueOf(sysset2395);
            if (numMod2 == 0) {
                reqNum = (int)Integer.valueOf(sysset2395);
            }
            else {
                int num3 = (int)Integer.valueOf(sysset2396) - numIsAssign2;
                int num4 = (int)Integer.valueOf(sysset2395) - numMod2;
                if (num3 >= num4) {
                    reqNum = num4;
                }
                else {
                    reqNum = num3;
                }
            }
        }
        else {
            MaExaminerInfo examinerInfo = esCarInfo.getMaExaminerInfoByExaminerId1();
            cardNo = esCarInfo.getMaExaminerInfoByExaminerId1().getCardNo();
            String sToday = CommonFileld.formatterYmd.format(new Date());
            String signTime = CommonFileld.formatterYmd.format(esCarInfo.getMaExaminerInfoByExaminerId1().getSignTime());
            boolean assignFlag = false;
            if (!signTime.equals(sToday)) {
                assignFlag = true;
            }
            else {
                StringBuilder sql = new StringBuilder();
                sql.append("select count(*) from es_drvpreasign t where t.ksy1sfzmhm='").append(cardNo).append("' and t.ykrq=trunc(sysdate)");
                int numIsAssign = this.examineeInfoDbAdapter.getMyIntegerValue(sql);
                int numMod = numIsAssign % (int)Integer.valueOf(sysset2395);
                if (numMod == 0 && numIsAssign > 0) {
                    assignFlag = true;
                    examinerInfo.setIsFlag("0");
                    this.examinerInfoDbAdapter.updateExaminerInfo(examinerInfo);
                    cardNo = esCarInfo.getMaExaminerInfoByExaminerId1().getCardNo();
                    reMark = "签退";
                    this.examinerLoginDbAdapter.saveExaminnerSign(Long.valueOf(kdid), cardNo, carCode, carType, reMark);
                    esCarInfo.setMaExaminerInfoByExaminerId1(null);
                    this.carExamInfoDbAdapter.updateCarInfo(esCarInfo);
                }
            }
            if (assignFlag) {
                examinerInfo = this.assignNewMaExaminerInfo(sysset2396, esCarInfo);
                if (examinerInfo == null) {
                    throw new RspException("1", "无有效安全员可用，请安全员继续签到！");
                }
                esCarInfo.setMaExaminerInfoByExaminerId1(examinerInfo);
                this.carExamInfoDbAdapter.updateCarInfo(esCarInfo);
                examinerInfo.setIsFlag("2");
                this.examinerInfoDbAdapter.updateExaminerInfo(examinerInfo);
                cardNo = esCarInfo.getMaExaminerInfoByExaminerId1().getCardNo();
                reMark = "分车";
                this.examinerLoginDbAdapter.saveExaminnerSign(Long.valueOf(kdid), cardNo, carCode, carType, reMark);
            }
            if (esCarInfo.getMaExaminerInfoByExaminerId().getId() != esCarInfo.getMaExaminerInfoByExaminerId1().getId()) {
                throw new RspException("1", "安全员错误，当前考车安全员是" + esCarInfo.getMaExaminerInfoByExaminerId1().getName());
            }
            StringBuilder sql = new StringBuilder();
            sql.append("select count(*) from es_drvpreasign t where t.ksy1sfzmhm='").append(cardNo).append("' and t.ykrq=trunc(sysdate)");
            int numIsAssign = this.examineeInfoDbAdapter.getMyIntegerValue(sql);
            int numMod = numIsAssign % (int)Integer.valueOf(sysset2395);
            int num1 = (int)Integer.valueOf(sysset2396) - numIsAssign;
            int num2 = (int)Integer.valueOf(sysset2395) - numMod;
            if (num1 >= num2) {
                reqNum = num2;
            }
            else {
                reqNum = num1;
            }
        }
        return reqNum;
    }
}
